'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	ATTACKmode:Int
Global	ATTACKold:Int[4]
Global	ATTACKmin:Int
Global	ATTACKmax:Int
Global	ATTACKwavemode:Int
Global	ATTACKwavetime:Long
Global	ATTACKwavetimedelta:Long
Global	ATTACKinitialtime:Long

Global	ATTACKvar01:Float
Global	ATTACKvar02:Float
Global	ATTACKvar03:Float

Global	ATTACKh1:Int
Global	ATTACKh2:Int
Global	ATTACKh3:Int
Global	ATTACKh4:Int

Global	ATTACKskill:Float

'Global	ATTACKlist:Int[]=[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]
'Global	ATTACKlist:Int[]=[1,2,3,4,1,22,1,2,3,10,11,4,5,12,6,7,8,23,14,15,16,13,23,17,18,19,20,9,21]
Global	ATTACKlist:Int[]=[1,2,3,4,1,5,1,2,3,22,10,11,4,5,12,6,7,8,23,14,15,16,13,23,17,18,19,20,9,21]

Const	ATTACKtotal:Int=29		'1 less than the max attack wave
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack Waves
'////////////////////////////////////////////////////////////////////////////////
Function	DoAttackWaves()
	Local	done:Int

	Select	ATTACKmode
		Case	0
			If ATTACKmax>4
				done=0
				Repeat
					ATTACKmode=ATTACKlist[Rand(ATTACKmin,ATTACKmax)]
					If ATTACKmode<>ATTACKold[0] And ATTACKmode<>ATTACKold[1] And ATTACKmode<>ATTACKold[2] And ATTACKmode<>ATTACKold[3]
						done=1
					End If
				Until(done=1)
				ATTACKwavemode=0
				ATTACKold[3]=ATTACKold[2]
				ATTACKold[2]=ATTACKold[1]
				ATTACKold[1]=ATTACKold[0]
				ATTACKold[0]=ATTACKmode
			Else
				ATTACKmode=ATTACKlist[Rand(ATTACKmin,ATTACKmax)]
				ATTACKwavemode=0
				ATTACKold[3]=ATTACKold[2]
				ATTACKold[2]=ATTACKold[1]
				ATTACKold[1]=ATTACKold[0]
				ATTACKold[0]=ATTACKmode
			End If
		Case	1
			AttackWave01()
		Case	2
			AttackWave02()
		Case	3
			AttackWave03()
		Case	4
			AttackWave04()
		Case	5
			AttackWave05()
		Case	6
			AttackWave06()
		Case	7
			AttackWave07()
		Case	8
			AttackWave08()
		Case	9
			AttackWave09()
		Case	10
			AttackWave10()
		Case	11
			AttackWave11()
		Case	12
			AttackWave12()
		Case	13
			AttackWave13()
		Case	14
			AttackWave14()
		Case	15
			AttackWave15()
		Case	16
			AttackWave16()
		Case	17
			AttackWave17()
		Case	18
			AttackWave18()
		Case	19
			AttackWave19()
		Case	20
			AttackWave20()
		Case	21
			AttackWave21()
		Case	22
			AttackWave22()
		Case	23
			AttackWave23()
	End Select

	ATTACKwavetime:+1
	If ATTACKwavetime>=ATTACKwavetimedelta
		ATTACKwavetime=0
		If ATTACKmax<ATTACKtotal
			ATTACKmax:+1
		End If
		If ATTACKskill>0.250
			ATTACKskill:-0.01
		End If
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 01	'Just adds a spinner							(Very Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave01()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=(Rand(ReqFPS/2,ReqFPS*2))*ATTACKskill
		Case	1
			AddSpinner(0,0)
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>ATTACKvar01
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 02	'Just adds a Floater							(Very Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave02()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=(Rand(ReqFPS/2,ReqFPS*2))*ATTACKskill
		Case	1
			AddFloater(0,0)
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>ATTACKvar01
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 03	'Just adds a Scare								(Very Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave03()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=(Rand(ReqFPS/2,ReqFPS*2))*ATTACKskill
		Case	1
			AddScare(0,0)
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>ATTACKvar01
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 04	'Just adds a Splitter							(Very Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave04()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=(Rand(ReqFPS/2,ReqFPS*2))*ATTACKskill
		Case	1
			AddSplitter(0,0)
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>ATTACKvar01
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 05	'Random Badguys									(Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave05()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=(Rand(ReqFPS,ReqFPS*3))*ATTACKskill
			ATTACKvar02=0
			ATTACKvar03=0
		Case	1
			For i=0 To Rand(2,12)
				Select Rand(0,3)
					Case	0
						AddSpinner(0,0)
					Case	1
						AddFloater(0,0)
					Case	2
						AddScare(0,0)
					Case	3
						AddSplitter(0,0)
				End Select
			Next
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>ATTACKvar01
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 06	'Floater 4 corner invasion						(Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave06()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(15,25)
			ATTACKvar03=Rand(2,3)
		Case	1
			ATTACKvar01:-1
			If ATTACKvar01=0
				ATTACKvar01=10
				AddFloater((WINleft+64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddFloater((WINleft+64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				AddFloater((WINright-64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddFloater((WINright-64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				ATTACKvar02:-1
				If ATTACKvar02=0
					ATTACKwavemode=2
				End If
			End If
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 07	'Scare 4 corner invasion						(Easy/Annoying)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave07()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(5,10)
			ATTACKvar03=Rand(5,8)
		Case	1
			ATTACKvar01:-1
			If ATTACKvar01=0
				ATTACKvar01=10
				AddScare((WINleft+64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddScare((WINleft+64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				AddScare((WINright-64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddScare((WINright-64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				ATTACKvar02:-1
				If ATTACKvar02=0
					ATTACKwavemode=2
				End If
			End If
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 08	'Splitter 4 corner invasion						(Quite Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave08()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(2,5)
			ATTACKvar03=Rand(3,6)
		Case	1
			ATTACKvar01:-1
			If ATTACKvar01=0
				ATTACKvar01=10
				AddSplitter((WINleft+64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddSplitter((WINleft+64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				AddSplitter((WINright-64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddSplitter((WINright-64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				ATTACKvar02:-1
				If ATTACKvar02=0
					ATTACKwavemode=2
				End If
			End If
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 09	'Swarmer 4 corner invasion						(Quite Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave09()
	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(30,50)
			ATTACKvar03=Rand(2,4)
		Case	1
			ATTACKvar01:-1
			If ATTACKvar01=0
				ATTACKvar01=8
				AddSwamer((WINleft+64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddSwamer((WINleft+64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				AddSwamer((WINright-64)+Rand(-32,32),(WINtop+64)+Rand(-32,32))
				AddSwamer((WINright-64)+Rand(-32,32),(WINbot-64)+Rand(-32,32))
				ATTACKvar02:-1
				If ATTACKvar02=0
					ATTACKwavemode=2
				End If
			End If
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 10	'Floater random invasion						(Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave10()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(3,12)
			ATTACKvar03=Rand(1,2)
		Case	1
			For i=0 To ATTACKvar02
				AddFloater(0,0)
			Next
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 11	'Scare random invasion							(Easy/Annoying)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave11()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(2,6)
			ATTACKvar03=Rand(1,2)
		Case	1
			For i=0 To ATTACKvar02
				AddScare(0,0)
			Next
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 12	'Splitter random invasion						(Quite Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave12()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(3,6)
			ATTACKvar03=Rand(1,2)
		Case	1
			For i=0 To ATTACKvar02
				AddSplitter(0,0)
			Next
			ATTACKwavemode=2
		Case	2
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 13	'Wait for there to be only 1 NME left
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave13()
	If	NMElist.count()<2
		ATTACKmode=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 14	'2 Snake Random Corner							(Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave14()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=0
			ATTACKvar02=0
			ATTACKvar03=0
			Select Rand(0,3)
				Case	0
					AddSnake((WINleft+64)+Rand(-32,128),(WINtop+64)+Rand(-32,128))
					AddSnake((WINleft+64)+Rand(-32,128),(WINtop+64)+Rand(-32,128))
				Case	1
					AddSnake((WINright-64)+Rand(-128,32),(WINtop+64)+Rand(-32,128))
					AddSnake((WINright-64)+Rand(-128,32),(WINtop+64)+Rand(-32,128))
				Case	2
					AddSnake((WINleft+64)+Rand(-32,128),(WINbot-64)+Rand(-128,32))
					AddSnake((WINleft+64)+Rand(-32,128),(WINbot-64)+Rand(-128,32))
				Case	3
					AddSnake((WINright-64)+Rand(-128,32),(WINbot-64)+Rand(-128,32))
					AddSnake((WINright-64)+Rand(-128,32),(WINbot-64)+Rand(-128,32))
			End Select
		Case	1
			ATTACKmode=0
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 15	'4 Snake Random Diagonal						(Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave15()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=0
			ATTACKvar02=0
			ATTACKvar03=0
			Select Rand(0,1)
				Case	0
					AddSnake((WINleft+64)+Rand(-32,128),(WINtop+64)+Rand(-32,128))
					AddSnake((WINleft+64)+Rand(-32,128),(WINtop+64)+Rand(-32,128))

					AddSnake((WINright-64)+Rand(-128,32),(WINbot-64)+Rand(-128,32))
					AddSnake((WINright-64)+Rand(-128,32),(WINbot-64)+Rand(-128,32))
				Case	1
					AddSnake((WINright-64)+Rand(-128,32),(WINtop+64)+Rand(-32,128))
					AddSnake((WINright-64)+Rand(-128,32),(WINtop+64)+Rand(-32,128))

					AddSnake((WINleft+64)+Rand(-32,128),(WINbot-64)+Rand(-128,32))
					AddSnake((WINleft+64)+Rand(-32,128),(WINbot-64)+Rand(-128,32))
			End Select
		Case	1
			ATTACKmode=0
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 16	'Random Number of Snakes in Random Corners			(Quite Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave16()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=0
			ATTACKvar02=0
			ATTACKvar03=0
			For i=4 To Rand(4,12)
				Select Rand(0,3)
					Case	0
						AddSnake((WINleft+64)+Rand(-32,128),(WINtop+64)+Rand(-32,128))
					Case	1
						AddSnake((WINright-64)+Rand(-128,32),(WINtop+64)+Rand(-32,128))
					Case	2
						AddSnake((WINleft+64)+Rand(-32,128),(WINbot-64)+Rand(-128,32))
					Case	3
						AddSnake((WINright-64)+Rand(-128,32),(WINbot-64)+Rand(-128,32))
				End Select
			Next
		Case	1
			ATTACKmode=0
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 17	'Floater Surround invasion							(Quite Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave17()
	Local	i:Float
	Local	j:Int
	Local	x:Float
	Local	y:Float
	Local	rad:Float

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(5,15)
			ATTACKvar03=Rand(3,6)
			rad=300
			For j=0 To 1
				For i=0 To 359 Step 16
					x=PLAYERx+Sin(i)*rad
					y=PLAYERy+Cos(i)*rad

					If x<(WINleft+16)
						x=(WINleft+16)
					Else
						If x>(WINright-16)
							x=(WINright-16)
						End If
					End If

					If y<(WINtop+16)
						y=(WINtop+16)
					Else
						If y>(WINbot-16)
							y=(WINbot-16)
						End If
					End If
					AddFloater(x,y)
				Next
				rad:+32
			Next
		Case	1
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 18	'Scare surround invasion						(Easy/Annoying)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave18()
	Local	i:Float
	Local	j:Int
	Local	x:Float
	Local	y:Float

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(3,8)
			ATTACKvar03=Rand(3,6)
			For i=0 To 359 Step 16
				x=PLAYERx+Sin(i)*300
				y=PLAYERy+Cos(i)*300

				If x<(WINleft+16)
					x=(WINleft+16)
				Else
					If x>(WINright-16)
						x=(WINright-16)
					End If
				End If
	
				If y<(WINtop+16)
					y=(WINtop+16)
				Else
					If y>(WINbot-16)
						y=(WINbot-16)
					End If
				End If
				AddScare(x,y)
			Next
		Case	1
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 19	'Splitter surround invasion						(Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave19()
	Local	i:Float
	Local	x:Float
	Local	y:Float

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(3,8)
			ATTACKvar03=Rand(3,6)
			For i=0 To 359 Step 24
				x=PLAYERx+Sin(i)*300
				y=PLAYERy+Cos(i)*300
				If x<(WINleft+16)
					x=(WINleft+16)
				Else
					If x>(WINright-16)
						x=(WINright-16)
					End If
				End If

				If y<(WINtop+16)
					y=(WINtop+16)
				Else
					If y>(WINbot-16)
						y=(WINbot-16)
					End If
				End If
				AddSplitter(x,y)
			Next
		Case	1
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 20	'Snake surround invasion							(Hard)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave20()
	Local	i:Float
	Local	x:Float
	Local	y:Float

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=1
			ATTACKvar02=Rand(3,8)
			ATTACKvar03=Rand(3,6)
			For i=0 To 359 Step 16
				x=PLAYERx+Sin(i)*300
				y=PLAYERy+Cos(i)*300
				If x<(WINleft+16)
					x=(WINleft+16)
				Else
					If x>(WINright-16)
						x=(WINright-16)
					End If
				End If

				If y<(WINtop+16)
					y=(WINtop+16)
				Else
					If y>(WINbot-16)
						y=(WINbot-16)
					End If
				End If
				AddSnake(x,y)
			Next
		Case	1
			If (GAMEtimeframes-ATTACKinitialtime)>((ReqFPS*ATTACKvar03)*ATTACKskill)
				ATTACKmode=0
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 21	'Clone Random Corner								(Easy)
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave21()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=0
			ATTACKvar02=0
			ATTACKvar03=0
			Select Rand(0,3)
				Case	0
					AddClone((WINleft+64)+Rand(-32,128),(WINtop+64)+Rand(-32,128))
				Case	1
					AddClone((WINright-64)+Rand(-128,32),(WINtop+64)+Rand(-32,128))
				Case	2
					AddClone((WINleft+64)+Rand(-32,128),(WINbot-64)+Rand(-128,32))
				Case	3
					AddClone((WINright-64)+Rand(-128,32),(WINbot-64)+Rand(-128,32))
			End Select
		Case	1
			ATTACKmode=0
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 22	'Random Balck Hole	
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave22()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKwavemode=1
			ATTACKvar01=0
			ATTACKvar02=0
			ATTACKvar03=0
			If PLAYERpowerup=0
				If CountHoles()<2
					Addhole(0,0)
				End If
			Else
				If CountHoles()<5
					Addhole(0,0)
				End If
			End If
		Case	1
			ATTACKmode=0
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Attack 23	'Balck Hole 4 Corner Spew
'////////////////////////////////////////////////////////////////////////////////
Function	AttackWave23()
	Local	i:Int

	Select	ATTACKwavemode
		Case	0
			ATTACKinitialtime=GAMEtimeframes
			ATTACKvar01=20
			ATTACKvar02=0
			ATTACKvar03=0
			ATTACKh1=0
			ATTACKh2=0
			ATTACKh3=0
			ATTACKh4=0
			If CountHoles()<5
				AddHole((WINleft+64),(WINtop+64))
				AddFloater((WINleft+64),(WINtop+64))
				AddScare((WINleft+64),(WINtop+64))
				AddSplitter((WINleft+64),(WINtop+64))
				AddFloater((WINleft+64),(WINtop+64))
			End If
			If CountHoles()<5
				AddHole((WINleft+64),(WINbot-64))
				AddFloater((WINleft+64),(WINbot-64))
				AddScare((WINleft+64),(WINbot-64))
				AddSplitter((WINleft+64),(WINbot-64))
				AddFloater((WINleft+64),(WINbot-64),0)
			End If
			If CountHoles()<5
				AddHole((WINright-64),(WINtop+64))
				AddFloater((WINright-64),(WINtop+64))
				AddScare((WINright-64),(WINtop+64))
				AddSplitter((WINright-64),(WINtop+64))
				AddFloater((WINright-64),(WINtop+64))
			End If
			If CountHoles()<5
				AddHole((WINright-64),(WINbot-64))
				AddFloater((WINright-64),(WINbot-64))
				AddScare((WINright-64),(WINbot-64))
				AddSplitter((WINright-64),(WINbot-64))
				AddFloater((WINright-64),(WINbot-64))
			End If
			ATTACKwavemode=1
		Case	1
			ATTACKvar01:-1
			If ATTACKvar01=0
				ATTACKmode=0
				ATTACKvar01=20
			End If
	End Select
End Function
