'////////////////////////////////////////////////////////////////////////////////
'//	Do Bomb
'////////////////////////////////////////////////////////////////////////////////
Function	DoBomb()
	Select	BOMBmode
		Case	1
			SetupBomb()
		Case	2
			MoveBomb()
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Bomb
'////////////////////////////////////////////////////////////////////////////////
Function	SetupBomb()
	BOMBx=PLAYERx
	BOMBy=PLAYERy
	BOMBrad=PLAYERcollrad/2
	BOMBspeed=16
	BOMBcollrad=16
	BOMBmode=2
	BOMBalpha=1

	PLAYERbombs:-1
	PLAYERshottime=0

	AddSFX(cSFXplayerbomb,-1)

	If GAMEaward[AWDPANSY]=0
		If PLAYERshield<>0
			GAMEaward[AWDPANSY]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWDSUCKER]=0
		If NMElist.count()=0
			GAMEaward[AWDSUCKER]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Move Bomb
'////////////////////////////////////////////////////////////////////////////////
Function	MoveBomb()
	Local	n:tNME
	Local	dis:Float
	Local	i:Int
	Local	hit:Int

	hit=0
	For	n:tNME = EachIn nmelist
		If n.mode=1
			dis=Sqr(((BOMBx-n.x)*(BOMBx-n.x))+((BOMBy-n.y)*(BOMBy-n.y)))
			If dis<(BOMBrad+BOMBcollrad) And dis>(BOMBrad-BOMBcollrad)
				n.mode=2
				n.score=0
				hit=1
			End If
		End If
	Next

	BOMBalpha:-0.02

	BOMBrad:+BOMBspeed
	If BOMBrad>800'1024
		BOMBmode=0
		If ATTACKwavemode<>0
			ATTACKmode=0
		End If
	End If

	AddImage(GFXplayerbomb01,BOMBx-WINDOWx,BOMBy-WINDOWy,0,64,200,255,BOMBalpha,0,BOMBrad/64,BOMBrad/64,lightBLEND)

	If hit=1
		'AddSFX(cSFXbombhit,-1)
		AddSFX(cSFXnmekill,-1)
	End If

	gridpoint.pull(BOMBx-GRIDxoff,BOMBy-GRIDyoff,BOMBrad/12,-(((1024-BOMBrad)/1024)*1.5))
End Function

