'////////////////////////////////////////////////////////////////////////////////
'//	Add Explosion
'////////////////////////////////////////////////////////////////////////////////
Function	AddExplosion(x:Float,y:Float)
	Local	part:tPART
	Local	r:Int
	Local	g:Int
	Local	b:Int
	Local	mr:Float

	r=Rand(64,255)
	g=Rand(64,255)
	b=Rand(64,255)

	If CONFexplosions>0
		part:tPART = New tPART
		part.t=1
		part.accel=0.0000001
		part.accelchange=0
		part.ang=0
		part.angchange=0
		part.x=x
		part.y=y
		part.rot=Rand(0,359)
		part.rotchange=0
		part.alpha=0.5+Rnd(0.5,1)
		part.alphachange=-0.04
		part.xscale=0
		part.yscale=0
		mr=Rnd(0.1,0.2)
		part.xscalechange=mr'0.125'0.075
		part.yscalechange=mr'0.125'0.075
		part.img=GFXpartex02
		part.blend=LIGHTBLEND
		part.r=r'Rand(64,255)
		part.g=g'Rand(64,255)
		part.b=b'Rand(64,255)
		part.collrad=0
		ListAddLast(particlelist,part)
	End If

	If CONFexplosions=2
		part:tPART = New tPART
		part.t=1
		part.accel=0.0000001
		part.accelchange=0
		part.ang=0
		part.angchange=0
		part.x=x
		part.y=y
		part.rot=Rand(0,359)
		part.rotchange=0
		part.alpha=0.5+Rnd(0.5,1)
		part.alphachange=-0.04
		part.xscale=0
		part.yscale=0
		mr=Rnd(0.2,0.3)
		part.xscalechange=mr'0.25'0.075
		part.yscalechange=mr'0.25'0.075
		part.img=GFXpartex01
		part.blend=LIGHTBLEND
		part.r=r'Rand(64,255)
		part.g=g'Rand(64,255)
		part.b=b'Rand(64,255)
		part.collrad=0
		ListAddLast(particlelist,part)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Add Explosion
'////////////////////////////////////////////////////////////////////////////////
Function	AddExplosionRed(x:Float,y:Float)
	Local	part:tPART
	Local	mr:Float

	part:tPART = New tPART
	part.t=1
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=x
	part.y=y
	part.rot=Rand(0,359)
	part.rotchange=0
	part.alpha=0.5+Rnd(0.5,1)
	part.alphachange=-0.04
	part.xscale=0
	part.yscale=0
	mr=Rnd(0.05,0.025)
	part.xscalechange=mr'0.125'0.075
	part.yscalechange=mr'0.125'0.075
	part.img=GFXpartex01
	part.blend=LIGHTBLEND
	part.r=255
	part.g=32
	part.b=32
	part.collrad=0
	ListAddLast(particlelist,part)

End Function
