'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	HIGHSCOREtablenames:String[100]
Global	HIGHSCOREtablescores:Long[100]
Global	HIGHSCOREtablesecs:Int[100]
Global	HIGHSCOREtablemins:Int[100]
Global	HIGHSCOREtablehours:Int[100]
Global	HIGHSCOREtablepage:Int
Global	HIGHSCOREtablelastscorepos:Int=-1
Global	HIGHSCOREfd:Int
Global	HIGHSCOREkd:Int
Global	HIGHSCOREjd:Int
Global	HIGHSCOREmd:Int
Global	HIGHSCOREtablemouseover:Int
Global	HIGHSCOREcryptkey:Int[]=[249,42,19,28,245,248,5,216,134,165,182,176,35,54,2,201,23,241,164,99,138,92,144,88,253,29,67,28,178,181,250,146,166,66,96,190,17,211,83,141,69,205,18,33,1,221,58,129,240,206,220,214,46,154,16,41,170,122,145,124,42,252,28,75,74,93,159,47,160,199,179,68,6,121,229,40,28,50,142,206,34,121,115,204,110,203,67,39,54,14,238,66,26,164,79,49,175,227,17,52,44,209,153,166,103,121,118,249,54,154,172,176,143,149,139,73,51,165,221,187,217,8,38,201,74,86,113,3]
Global	HIGHSCOREcryptkeypoint:Int
Global	HIGHSCOREentryy:Int
Global	HIGHSCOREentryx:Int
Global	HIGHSCOREentrycury:Int
Global	HIGHSCOREentrycurx:Int
Global	HIGHSCOREentrycurdone:Int
Global	HIGHSCOREentryflash:Int
Global	HIGHSCOREentry:String
Global	HIGHSCOREentrylastname:String=""
LoadHighscores()
'////////////////////////////////////////////////////////////////////////////////
'//	Load Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	LoadHighscores()
	Local	i:Int
	Local	j:Int
	Local	file:TStream
	Local	data1:Long
	Local	data2:Long
	Local	data3:Long
	Local	data4:Long
	Local	data5:Long
	Local	data6:Byte
	Local	data7:Int
	Local	str:String

	file=OpenFile("highscore.dat",True,False)

	HIGHSCOREcryptkeypoint=0

	If file=Null
		For i=0 To 99
			HIGHSCOREtablenames[i]="Empty"
			HIGHSCOREtablescores[i]=0
			HIGHSCOREtablesecs[i]=0
			HIGHSCOREtablemins[i]=0
			HIGHSCOREtablehours[i]=0
		Next
		For i=0 To 13
			PLAYERachievments[i]=0
		Next
	Else
		For i=0 To 99
			data1=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data3=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data4=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=(data2 Shl 8)
			data3=(data3 Shl 16)
			data4=(data4 Shl 24)
			data5=(data1 | data2 | data3 | data4)
			HIGHSCOREtablescores[i]=data5
		Next	

		For i=0 To 99
			data1=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data3=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data4=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=(data2 Shl 8)
			data3=(data3 Shl 16)
			data4=(data4 Shl 24)
			data5=(data1 | data2 | data3 | data4)
			HIGHSCOREtablesecs[i]=data5
		Next	

		For i=0 To 99
			data1=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data3=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data4=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=(data2 Shl 8)
			data3=(data3 Shl 16)
			data4=(data4 Shl 24)
			data5=(data1 | data2 | data3 | data4)
			HIGHSCOREtablemins[i]=data5
		Next	

		For i=0 To 99
			data1=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data3=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data4=Long(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			data2=(data2 Shl 8)
			data3=(data3 Shl 16)
			data4=(data4 Shl 24)
			data5=(data1 | data2 | data3 | data4)
			HIGHSCOREtablehours[i]=data5
		Next	

		For i=0 To 13
			data7=Int(ReadByte(file)) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			PLAYERachievments[i]=data7
		Next

		For i=0 To 99
			str=""
			For j=1 To Int(ReadByte(file))
				data6=ReadByte(file)
				data6=data6 ~ Byte(HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint])
				str=str+Chr$(data6)
				HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
			Next
			HIGHSCOREtablenames[i]=str
		Next
		CloseFile(file)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Save Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	SaveHighscores()
	Local	file:TStream
	Local	data1:Long
	Local	data2:Long
	Local	data3:Byte
	Local	i:Int
	Local	j:Int
	Local	s:String

	file=OpenFile("highscore.dat",False,True)

	HIGHSCOREcryptkeypoint=0

	For i=0 To 99
		data1=HIGHSCOREtablescores[i]
		data2=(data1&255) ~  HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
	Next

	For i=0 To 99
		data1=HIGHSCOREtablesecs[i]
		data2=(data1&255) ~  HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
	Next

	For i=0 To 99
		data1=HIGHSCOREtablemins[i]
		data2=(data1&255) ~  HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
	Next

	For i=0 To 99
		data1=HIGHSCOREtablehours[i]
		data2=(data1&255) ~  HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
		data1=(data1 Shr 8)
		data2=(data1&255) ~ HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
	Next

	For i=0 To 13
		data1=PLAYERachievments[i]
		data2=(data1&255) ~  HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint]
		HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		WriteByte(file,Byte(data2))
	Next

	For i=0 To 99
		WriteByte(file,Byte(Len(HIGHSCOREtablenames[i])))
		For j=1 To Len(HIGHSCOREtablenames[i])
			data3=Asc(Mid$(HIGHSCOREtablenames[i],j,1))
			data3=data3 ~ Byte(HIGHSCOREcryptkey[HIGHSCOREcryptkeypoint])
			WriteByte(file,data3)
			HIGHSCOREcryptkeypoint=(HIGHSCOREcryptkeypoint+1) Mod 128
		Next
	Next
	CloseFile(file)

'	If HIGHSCOREtablescores[0]>0
'		UPLOADscoretable[0]=HIGHSCOREtablescores[0]
'		UPLOADscoretable[1]=HIGHSCOREtablehours[0]
'		UPLOADscoretable[2]=HIGHSCOREtablemins[0]
'		UPLOADscoretable[3]=HIGHSCOREtablesecs[0]
'		UPLOADname=HIGHSCOREtablenames[0]
'
'		UPLOADtext=uuencode_generic(84,4,UPLOADscoretable,UPLOADsizetable)
'
'		file:TStream=OpenFile("highscorecode.txt",False,True)
'		WriteLine(file,UPLOADtext)
'		CloseFile(file)
'	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	SetupHighscoreDisplay()
	Local	i:tMENU
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.5)
	i.entries=12
	i.text[0]=" "
	i.text[1]=" "
	i.text[2]=" "
	i.text[3]=" "
	i.text[4]=" "
	i.text[5]=" "
	i.text[6]=" "
	i.text[7]=" "
	i.text[8]=" "
	i.text[9]=" "
	i.text[10]=" "
	i.text[11]=" "
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	If HIGHSCOREtablelastscorepos<>-1
		HIGHSCOREtablepage=((HIGHSCOREtablelastscorepos-1)/10)
	Else
		HIGHSCOREtablepage=0
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Display Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	DisplayHighscores()
	Local	page:Int
	Local	s:String
	Local	i:Int
	Local	jx:Float
	Local	mx:Int
	Local	my:Int

	ClearList(DRAWlist)
	ClearSFX()
	DrawStars()

	DoParticles()

	PrintGame("H I G H S C O R E S",GFXw/2,GFXh*0.045,32,255,32,1,ALPHABLEND,1,1,1)

	DoMenus()

	page=(HIGHSCOREtablepage*10)
	For i=0 To 9
		s$=(page+1)+i
		If Len(s$)<2
			s$="  "+s$
		Else
			If Len(s$)<3
				s$=" "+s$
			End If
		End If
		If ((page+i)+1)=HIGHSCOREtablelastscorepos
			PrintGame(s$+".",(GFXw*0.05),(GFXh*0.2)+(i*32),255,255,32,0,ALPHABLEND,1)
			PrintGame(HIGHSCOREtablenames[page+i],(GFXw*0.15),(GFXh*0.2)+(i*32),255,255,32,0,ALPHABLEND,1)
			s$=FormatScore(HIGHSCOREtablescores[page+i])
			PrintGame(s$,(GFXw*0.8),(GFXh*0.2)+(i*32),255,255,32,0,ALPHABLEND,1)
		Else
			PrintGame(s$+".",(GFXw*0.05),(GFXh*0.2)+(i*32),32,255,32,0,ALPHABLEND,1)
			PrintGame(HIGHSCOREtablenames[page+i],(GFXw*0.15),(GFXh*0.2)+(i*32),32,255,32,0,ALPHABLEND,1)
			s$=FormatScore(HIGHSCOREtablescores[page+i])
			PrintGame(s$,(GFXw*0.8),(GFXh*0.2)+(i*32),32,255,32,0,ALPHABLEND,1)
		End If
	Next

	mx=MouseX()
	my=MouseY()

	If mx>((GFXw*0.4)-40) And mx<((GFXw*0.4)+16) And my>((GFXh*0.775)-8) And my<((GFXh*0.775)+32)
		HIGHSCOREtablemouseover=1
	Else
		If mx>((GFXw*0.5)-40) And mx<((GFXw*0.5)+24) And my>((GFXh*0.77)) And my<((GFXh*0.77)+28)
			HIGHSCOREtablemouseover=2
		Else
			If mx>((GFXw*0.6)-40) And mx<((GFXw*0.6)+16) And my>((GFXh*0.775)-8) And my<((GFXh*0.775)+32)
				HIGHSCOREtablemouseover=3
			Else
				HIGHSCOREtablemouseover=0
			End If
		End If
	End If


	Select HIGHSCOREtablemouseover
		Case	0
			PrintGame("<<<<",GFXw*0.4,GFXh*0.775,32,255,32,1,ALPHABLEND,1)
			PrintGame("back",GFXw*0.5,GFXh*0.77,16,192,16,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.6,GFXh*0.775,32,255,32,1,ALPHABLEND,1)
		Case	1
			PrintGame("<<<<",GFXw*0.4,GFXh*0.775,255,255,32,1,ALPHABLEND,1)
			PrintGame("back",GFXw*0.5,GFXh*0.77,16,192,16,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.6,GFXh*0.775,32,255,32,1,ALPHABLEND,1)
		Case	2
			PrintGame("<<<<",GFXw*0.4,GFXh*0.775,32,255,32,1,ALPHABLEND,1)
			PrintGame("back",GFXw*0.5,GFXh*0.77,255,255,16,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.6,GFXh*0.775,32,255,32,1,ALPHABLEND,1)
		Case	3
			PrintGame("<<<<",GFXw*0.4,GFXh*0.775,32,255,32,1,ALPHABLEND,1)
			PrintGame("back",GFXw*0.5,GFXh*0.77,16,192,16,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.6,GFXh*0.775,255,255,32,1,ALPHABLEND,1)
	End Select

	PrintGame(Chr$(127)+" 2006 "+WHOIS+".",GFXw/2,GFXh-48,32,255,32,1,ALPHABLEND,1)
	PrintGame(VERTXT,GFXw*0.95,GFXh-24,32,255,32,1,ALPHABLEND,0.25,0.5,0.5)
	AddImage(GFXplayersight,mx,my,0,64,255,64,1,0,1,1,alphaBLEND)

	If JoyDown(0) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or KeyDown(KEY_ESCAPE)
		If HIGHSCOREfd=0
			HIGHSCOREfd=1
			TITLEMODE=1
			ClearList(MENUlist)
			SetupMenu()
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		HIGHSCOREfd=0
	End If

	If MouseDown(1)
		If HIGHSCOREmd=0
			HIGHSCOREmd=1
			Select HIGHSCOREtablemouseover
				Case	1
					If HIGHSCOREtablepage>0
						HIGHSCOREtablepage:-1
					End If
				Case	2
					TITLEMODE=1
					ClearList(MENUlist)
					SetupMenu()
					AddSFX(cSFXmenuaccept,-1)
				Case	3
					If HIGHSCOREtablepage<9
						HIGHSCOREtablepage:+1
					End If
			End Select
		End If
	Else
		HIGHSCOREmd=0
	End If

	jx=JoyX(0)
	If (jx<-0.5 Or KeyDown(CONTROLleft) Or KeyDown(KEY_LEFT)) And HIGHSCOREtablepage>0
		If HIGHSCOREkd=0
			HIGHSCOREtablepage:-1
			HIGHSCOREkd=1
		End If
	Else
		If (jx>0.5 Or KeyDown(CONTROLright) Or KeyDown(KEY_RIGHT)) And HIGHSCOREtablepage<9
			If HIGHSCOREkd=0
				HIGHSCOREtablepage:+1
				HIGHSCOREkd=1
			End If
		Else
			HIGHSCOREkd=0
		End If
	End If

	TITLEfwpause:-1
	If TITLEfwpause<0
		AddExplosion(Rnd(WINleft,WINright),Rnd(WINtop,WINbot))
		TITLEfwpause=2
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Find Place in Highscore if any
'////////////////////////////////////////////////////////////////////////////////
Function	FindHighscore:Int(score:Long)
	Local	i:Int
	Local	j:Int
	Local	done:Int

	done=0
	i=0
	Repeat
		If score>=HIGHSCOREtablescores[i]
			done=1
		Else
			i:+1
		End If
		If i=100
			done=1
			i=-2
		End If
	Until(done=1)

	If i<>-2
		For j=98 To i Step-1
			HIGHSCOREtablescores[j+1]=HIGHSCOREtablescores[j]
			HIGHSCOREtablenames[j+1]=HIGHSCOREtablenames[j]
		Next
		HIGHSCOREtablescores[i]=score
		HIGHSCOREtablenames[i]=" "
		HIGHSCOREtablesecs[i]=GAMEtimesecs
		HIGHSCOREtablemins[i]=GAMEtimemins
		HIGHSCOREtablehours[i]=GAMEtimehours
	End If

	Return(i)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	SetupHighscoreEntry()
	Local	i:tMENU
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.5)
	i.entries=12
	i.text[0]=" "
	i.text[1]=" "
	i.text[2]=" "
	i.text[3]=" "
	i.text[4]=" "
	i.text[5]=" "
	i.text[6]=" "
	i.text[7]=" "
	i.text[8]=" "
	i.text[9]=" "
	i.text[10]=" "
	i.text[11]=" "
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	If HIGHSCOREtablelastscorepos<>-1
		HIGHSCOREtablepage=((HIGHSCOREtablelastscorepos-1)/10)
	Else
		HIGHSCOREtablepage=0
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Display Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	DisplayHighscoreEntry()
	Local	page:Int
	Local	s:String
	Local	i:Int
	Local	jx:Float
	Local	mx:Int
	Local	my:Int

	ClearList(DRAWlist)
	ClearSFX()
	DrawStars()
	DoParticles()

	PrintGame("H I G H S C O R E S",GFXw/2,GFXh*0.045,32,255,32,1,ALPHABLEND,1,1,1)

	DoMenus()

	page=(HIGHSCOREtablepage*10)
	For i=0 To 9
		s$=(page+1)+i
		If Len(s$)<2
			s$="  "+s$
		Else
			If Len(s$)<3
				s$=" "+s$
			End If
		End If
		If ((page+i)+1)=HIGHSCOREtablelastscorepos
			PrintGame(s$+".",(GFXw*0.05),(GFXh*0.2)+(i*32),255,255,32,0,ALPHABLEND,1)
			PrintGame(HIGHSCOREtablenames[page+i],(GFXw*0.15),(GFXh*0.2)+(i*32),255,255,32,0,ALPHABLEND,1)
			s$=FormatScore(HIGHSCOREtablescores[page+i])
			PrintGame(s$,(GFXw*0.8),(GFXh*0.2)+(i*32),255,255,32,0,ALPHABLEND,1)
			HIGHSCOREentryx=((GFXw*0.15))
			HIGHSCOREentryy=(GFXh*0.2)+(i*32)
			If HIGHSCOREentrycurdone=0
				HIGHSCOREentrycurx=((GFXw*0.15))
				HIGHSCOREentrycury=(GFXh*0.2)+(i*32)
				HIGHSCOREentrycurdone=1
				If HIGHSCOREentry<>""
					HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))
				End If
			End If
		Else
			PrintGame(s$+".",(GFXw*0.05),(GFXh*0.2)+(i*32),32,255,32,0,ALPHABLEND,1)
			PrintGame(HIGHSCOREtablenames[page+i],(GFXw*0.15),(GFXh*0.2)+(i*32),32,255,32,0,ALPHABLEND,1)
			s$=FormatScore(HIGHSCOREtablescores[page+i])
			PrintGame(s$,(GFXw*0.8),(GFXh*0.2)+(i*32),32,255,32,0,ALPHABLEND,1)
		End If
	Next

	mx=MouseX()
	my=MouseY()

	If mx>((GFXw*0.5)-40) And mx<((GFXw*0.5)+24) And my>((GFXh*0.77)) And my<((GFXh*0.77)+28)
		HIGHSCOREtablemouseover=1
	Else
		HIGHSCOREtablemouseover=0
	End If

	HIGHSCOREentryflash=(HIGHSCOREentryflash+8) Mod 256
	If HIGHSCOREentryflash>127
		PrintGame(Chr$(128),HIGHSCOREentrycurx,HIGHSCOREentrycury,32,255,255,0,ALPHABLEND,1)
	End If

	GetHighScoreEntry()

	If 		HIGHSCOREentry<>""
		PrintGame(HIGHSCOREentry,HIGHSCOREentryx,HIGHSCOREentryy,32,255,255,0,ALPHABLEND,1)
	End If

	Select HIGHSCOREtablemouseover
		Case	0
			PrintGame("done",GFXw*0.5,GFXh*0.77,16,192,16,1,ALPHABLEND,1)
		Case	1
			PrintGame("done",GFXw*0.5,GFXh*0.77,255,255,32,1,ALPHABLEND,1)
	End Select

	PrintGame(Chr$(127)+" 2006 "+WHOIS+".",GFXw/2,GFXh-48,32,255,32,1,ALPHABLEND,1)
	PrintGame(VERTXT,GFXw*0.95,GFXh-24,32,255,32,1,ALPHABLEND,0.25,0.5,0.5)
	AddImage(GFXplayersight,mx,my,0,64,255,64,1,0,1,1,alphaBLEND)

	If MouseDown(1)
		If HIGHSCOREmd=0
			HIGHSCOREmd=1
			Select HIGHSCOREtablemouseover
				Case	1
					If HIGHSCOREentry<>""
						HIGHSCOREtablenames[HIGHSCOREtablelastscorepos-1]=HIGHSCOREentry
					Else
						HIGHSCOREtablenames[HIGHSCOREtablelastscorepos-1]="Anonymous"
					End If
					HIGHSCOREentrylastname=HIGHSCOREentry
					TITLEMODE=1
					ClearList(MENUlist)
					SetupMenu()
					AddSFX(cSFXmenuaccept,-1)
			End Select
		End If
	Else
		HIGHSCOREmd=0
	End If

	If KeyDown(KEY_RETURN) Or KeyDown(KEY_ESCAPE) Or JoyDown(0)
		If HIGHSCOREfd=0
			If HIGHSCOREentry<>""
				HIGHSCOREtablenames[HIGHSCOREtablelastscorepos-1]=HIGHSCOREentry
			Else
				HIGHSCOREtablenames[HIGHSCOREtablelastscorepos-1]="Anonymous"
			End If
			HIGHSCOREentrylastname=HIGHSCOREentry
			TITLEMODE=1
			ClearList(MENUlist)
			SetupMenu()
			AddSFX(cSFXmenuaccept,-1)
			HIGHSCOREfd=1
		End If
	Else
		HIGHSCOREfd=0
	End If


	TITLEfwpause:-1
	If TITLEfwpause<0
		AddExplosion(Rnd(WINleft,WINright),Rnd(WINtop,WINbot))
		TITLEfwpause=2
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Get High Score Entry()
'////////////////////////////////////////////////////////////////////////////////
Function	GetHighScoreEntry()
	Local	i:Int
	Local	done:Int
	Local	charsl:String="``````````````````````````````` ```````````````0123456789```````abcdefghijklmnopqrstuvwxyz```````````````*+/-./``````````````````````````````````````````````````````````````````````````;=,-./?``````````````````````````[\]+``````````````````````````````````"
	Local	charsu:String="``````````````````````````````` ````````````````!@#$%^&*(```````ABCDEFGHIJKLMNOPQRSTUVWXYZ`````0123456789*+/-./`````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````````"
	Local	cur:String
	Local	oldstring:String

	Local	joystringl:String=" abcdefghijklmnopqrstuvwxyz0123456789!:;()[]?*+-/\.,&$@%ABCDEFGHIJKLMNOPQRSTUVWXYZ"'82

	Local	jy:Float
	Local	jx:Float
	Local	pos:Int

	done=0

	If AnyKey2()=1
		If HIGHSCOREkd=0
			HIGHSCOREkd=1
			For i=0 To 255
				If done=0
					If KeyDown(i)
						If i=8
							If HIGHSCOREentry<>""
								HIGHSCOREentry=(Left$(HIGHSCOREentry,Len(HIGHSCOREentry)-1))
							End If
							HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))
						Else
							If KeyDown(KEY_RSHIFT) Or KeyDown(KEY_LSHIFT)
								cur=Mid$(charsu,i,1)
							Else
								cur=Mid$(charsl,i,1)
							End If
							If cur<>"`"
								oldstring=HIGHSCOREentry
								HIGHSCOREentry=(HIGHSCOREentry+cur)
								If GetStringLen(HIGHSCOREentry)>496
									HIGHSCOREentry=oldstring
								End If
								HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))
							End If
						End If
						done=1
					End If
				End If
			Next
		End If
	Else
		HIGHSCOREkd=0
	End If

	jx=JoyGet(0)
	jy=JoyGet(1)

	If jy>0.75
		If HIGHSCOREjd=0
			cur=Right$(HIGHSCOREentry,1)
			pos=Instr(joystringl,cur,1)

			pos:-1
			If pos=0
				pos=82
			End If
		
			oldstring=HIGHSCOREentry

			If HIGHSCOREentry<>""
				HIGHSCOREentry=Mid$(HIGHSCOREentry,1,Len(HIGHSCOREentry)-1)
				HIGHSCOREentry=HIGHSCOREentry+Mid$(joystringl,pos,1)
			Else
				HIGHSCOREentry=Mid$(joystringl,pos,1)
			End If

			If GetStringLen(HIGHSCOREentry)>496
				HIGHSCOREentry=oldstring
			End If
			HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))

			HIGHSCOREjd=1
		End If
	Else
		If jy<-0.75
			If HIGHSCOREjd=0
				cur=Right$(HIGHSCOREentry,1)
				pos=Instr(joystringl,cur,1)

				pos:+1
				If pos=83
					pos=1
				End If
		
				oldstring=HIGHSCOREentry

				If HIGHSCOREentry<>""
					HIGHSCOREentry=Mid$(HIGHSCOREentry,1,Len(HIGHSCOREentry)-1)
					HIGHSCOREentry=HIGHSCOREentry+Mid$(joystringl,pos,1)
				Else
					HIGHSCOREentry=Mid$(joystringl,pos,1)
				End If

				If GetStringLen(HIGHSCOREentry)>496
					HIGHSCOREentry=oldstring
				End If
				HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))

				HIGHSCOREjd=1
			End If
		Else
			If jx<-0.75
				If HIGHSCOREjd=0
					oldstring=HIGHSCOREentry

					If HIGHSCOREentry<>""
						HIGHSCOREentry=Mid$(HIGHSCOREentry,1,Len(HIGHSCOREentry)-1)
					End If

					If GetStringLen(HIGHSCOREentry)>496
						HIGHSCOREentry=oldstring
					End If
					HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))

					HIGHSCOREjd=1
				End If
			Else
				If jx>0.75
					If HIGHSCOREjd=0
						oldstring=HIGHSCOREentry

						If HIGHSCOREentry<>""
							HIGHSCOREentry=HIGHSCOREentry+Right$(HIGHSCOREentry,1)
						Else
							HIGHSCOREentry=HIGHSCOREentry+" "
						End If

						If GetStringLen(HIGHSCOREentry)>496
							HIGHSCOREentry=oldstring
						End If
						HIGHSCOREentrycurx=(HIGHSCOREentryx+GetStringLen(HIGHSCOREentry))
						
						HIGHSCOREjd=1
					End If
				Else
					HIGHSCOREjd=0
				End If
			End If
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	SetupHighscoreDisplay2()
	Local	i:tMENU
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.5)
	i.entries=10
	i.text[0]=" "
	i.text[1]=" "
	i.text[2]=" "
	i.text[3]=" "
	i.text[4]=" "
	i.text[5]=" "
	i.text[6]=" "
	i.text[7]=" "
	i.text[8]=" "
	i.text[9]=" "
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	If HIGHSCOREtablelastscorepos<>-1
		HIGHSCOREtablepage=((HIGHSCOREtablelastscorepos-1)/10)
	Else
		HIGHSCOREtablepage=0
	End If

	TITLEoldmy=MouseY()
	TITLEoldmx=MouseX()

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Display Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	DisplayHighscores2()
	Local	page:Int
	Local	s:String
	Local	i:Int
	Local	jx:Float
	Local	mx:Int
	Local	my:Int

	ClearList(DRAWlist)
	ClearSFX()
	DrawStars()

	DoParticles()

	PrintGame("H I G H S C O R E S",GFXw/2,GFXh*0.045,32,255,32,1,ALPHABLEND,1,1,1)

	DoMenus()

	page=(HIGHSCOREtablepage*10)
	For i=0 To 9
		s$=(page+1)+i
		If Len(s$)<2
			s$="  "+s$
		Else
			If Len(s$)<3
				s$=" "+s$
			End If
		End If
		If ((page+i)+1)=HIGHSCOREtablelastscorepos
			PrintGame(s$+".",(GFXw*0.05),(GFXh*0.24)+(i*32),255,255,32,0,ALPHABLEND,1)
			PrintGame(HIGHSCOREtablenames[page+i],(GFXw*0.15),(GFXh*0.24)+(i*32),255,255,32,0,ALPHABLEND,1)
			s$=FormatScore(HIGHSCOREtablescores[page+i])
			PrintGame(s$,(GFXw*0.8),(GFXh*0.24)+(i*32),255,255,32,0,ALPHABLEND,1)
		Else
			PrintGame(s$+".",(GFXw*0.05),(GFXh*0.24)+(i*32),32,255,32,0,ALPHABLEND,1)
			PrintGame(HIGHSCOREtablenames[page+i],(GFXw*0.15),(GFXh*0.24)+(i*32),32,255,32,0,ALPHABLEND,1)
			s$=FormatScore(HIGHSCOREtablescores[page+i])
			PrintGame(s$,(GFXw*0.8),(GFXh*0.24)+(i*32),32,255,32,0,ALPHABLEND,1)
		End If
	Next

	PrintGame(Chr$(127)+" 2006 "+WHOIS+".",GFXw/2,GFXh-48,32,255,32,1,ALPHABLEND,1)
	PrintGame(VERTXT,GFXw*0.95,GFXh-24,32,255,32,1,ALPHABLEND,0.25,0.5,0.5)
	mx=MouseX()
	my=MouseY()
	AddImage(GFXplayersight,mx,my,0,64,255,64,1,0,1,1,alphaBLEND)

	If AnyKey()=1 Or AnyJoy()=1 Or MouseDown(1) Or MouseDown(2) 'Or TITLEoldmy<>my Or TITLEoldmx<>mx
		If HIGHSCOREfd=0
			HIGHSCOREfd=1
			TITLEMODE=1
			ClearList(MENUlist)
			SetupMenu()
			TITLEcount=TITLEcountreset
		End If
	Else
		HIGHSCOREfd=0
	End If

	TITLEfwpause:-1
	If TITLEfwpause<0
		AddExplosion(Rnd(WINleft,WINright),Rnd(WINtop,WINbot))
		TITLEfwpause=2
	End If

	TITLEcount:-1
	If TITLEcount<0
		ClearList(MENUlist)
		SetupTitles()
		TITLEcount=TITLEcountreset
		TITLEmode=1
	End If

	TITLEoldmy=my
	TITLEoldmx=mx
End Function
