'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Const	PLAYERMAXACCEL:Float=4
Const	PLAYERFRICTION:Float=0.25
Const	PLAYERACCEL:Float=1

Global	GFXplayer:TImage
Global	GFXplayersight:TImage
Global	GFXplayershield:TImage
Global	GFXplayerrez01:TImage
Global	GFXplayerrez02:TImage
Global	GFXplayerrez03:TImage
Global	GFXplayerrez04:TImage
Global	GFXplayerrez05:TImage

Global	GFXthrust01:TImage

Global	GFXplayerbomb01:TImage

Global	SFXplayerfire01:TSound
Global	SFXplayerfire02:TSound
Global	SFXplayerfire03:TSound
Global	SFXplayerexp:TSound
Global	SFXplayerbomb:TSound
Global	SFXplayerbombhit:TSound
Global	SFXplayerrez:TSound
Global	SFXplayershield:TSound

Global	PLAYERmode:Int
Global	PLAYERx:Float
Global	PLAYERy:Float
Global	PLAYERxacc:Float
Global	PLAYERyacc:Float
Global	PLAYERcollrad:Float
Global	PLAYERang:Float
Global	PLAYERengang:Float
Global	PLAYERpowerup:Int
Global	PLAYERpowerupdelta:Float
Global	PLAYERpowerupdeltaadd:Float
Global	PLAYERnextshot:Int
Global	PLAYERnextshotreset:Int
Global	PLAYERfiretoggle:Int
Global	PLAYERshield:Int
Global	PLAYERrezrot:Float
Global	PLAYERrezscale:Float
Global	PLAYERrezalpha:Float
Global	PLAYERrezalpha2:Float
Global	PLAYERdeathcount:Int
Global	PLAYERlifes:Int
Global	PLAYERlifesdelta:Long
Global	PLAYERlifesdeltaadd:Long
Global	PLAYERbombs:Int
Global	PLAYERbombsdelta:Long
Global	PLAYERbombsdeltaadd:Long
Global	PLAYERscore:Long
Global	PLAYERmultiply:Long
Global	PLAYERmultiplydelta:Long
Global	PLAYERshite:Int
Global	PLAYERhasdied:Int
Global	PLAYERshottime:Long

Global	PLAYERachievments:Int[]=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

Global	SIGHTx:Float
Global	SIGHTy:Float
Global	SIGHTa:Float

Global	BOMBmode:Int
Global	BOMBx:Float
Global	BOMBy:Float
Global	BOMBrad:Float
Global	BOMBspeed:Float
Global	BOMBcollrad:Float
Global	BOMBalpha:Float

'////////////////////////////////////////////////////////////////////////////////
'//	Setup Player
'////////////////////////////////////////////////////////////////////////////////
Function	SetupPlayer()
	SIGHTx=MouseX()+WINDOWx
	SIGHTy=MouseY()+WINDOWy
	SIGHTa=ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)

	PLAYERmode=0
	PLAYERx=(((WINright-WINleft)/2)+WINleft)
	PLAYERy=(((WINbot-WINtop)/2)+WINtop)
	PLAYERxacc=0
	PLAYERyacc=0
	PLAYERcollrad=14
	PLAYERang=0
	PLAYERpowerup=0
	PLAYERpowerupdelta=10000
	PLAYERpowerupdeltaadd=10000
	PLAYERnextshot=0
	PLAYERnextshotreset=6
	PLAYERfiretoggle=0
	PLAYERshield=200
	PLAYERlifes=3
	PLAYERlifesdelta=75000
	PLAYERlifesdeltaadd=75000
	PLAYERbombs=3
	PLAYERbombsdelta=100000
	PLAYERbombsdeltaadd=100000
	PLAYERscore=0
	PLAYERmultiply=1
	PLAYERmultiplydelta=25
	PLAYERshite=0
	PLAYERhasdied=0

	PLAYERrezrot=0
	PLAYERrezscale=6
	PLAYERrezalpha=1
	PLAYERrezalpha2=1

	PLAYERshottime=0

	BOMBmode=0

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Reset Player
'////////////////////////////////////////////////////////////////////////////////
Function	ResetPlayer()
	SIGHTx=MouseX()+WINDOWx
	SIGHTy=MouseY()+WINDOWy

	PLAYERmode=0
	PLAYERxacc=0
	PLAYERyacc=0
	PLAYERcollrad=14
	PLAYERnextshot=0
	PLAYERfiretoggle=0
	PLAYERshield=200
	PLAYERmultiply=1
	PLAYERmultiplydelta=25

	PLAYERrezrot=0
	PLAYERrezscale=6
	PLAYERrezalpha=1
	PLAYERrezalpha2=1

	PLAYERshottime=0

	BOMBmode=0

	If PLAYERshite=0
		PLAYERpowerup=0
		PLAYERnextshotreset=6
	End If
	PLAYERshite=0
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Player
'////////////////////////////////////////////////////////////////////////////////
Function	DoPlayer()
	Select	PLAYERmode
		Case	0
			RezInPlayer()
		Case	1
			MovePlayer()
			PlayerCheckDeath()

			If GAMEaward[AWDPACIFIST]=0
				PLAYERshottime:+1
				If PLAYERshottime>(ReqFPS*60) 
					GAMEaward[AWDPACIFIST]=1
					AddSFX(cSFXaward,-1)
				End If
			End If
		Case	3
			PlayerDeath()
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Player
'////////////////////////////////////////////////////////////////////////////////
Function	RezInPlayer()
	If PLAYERrezalpha=1.0
		AddSFX(cSFXplayerstart,-1)
	End If

	SIGHTx=MouseX()+WINDOWx
	SIGHTy=MouseY()+WINDOWy

	AddImage(GFXplayer,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,255,255,255,1,PLAYERang,1,1,lightBLEND)

	AddImage(GFXplayerrez01,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,255,255,PLAYERrezalpha,PLAYERrezrot,PLAYERrezscale,PLAYERrezscale,lightBLEND)

	AddImage(GFXplayerrez02,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,255,255,PLAYERrezalpha,-PLAYERrezrot,PLAYERrezscale,PLAYERrezscale,lightBLEND)

	AddImage(GFXplayerrez03,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,255,255,PLAYERrezalpha2,0,12-(PLAYERrezscale*2),12-(PLAYERrezscale*2),lightBLEND)

	PLAYERrezrot:+2
	PLAYERrezscale:-0.1
	PLAYERrezalpha:-0.02
	PLAYERrezalpha2:-0.02

	If PLAYERrezalpha2<0
		PLAYERmode=1
		GAMEMODE=2
	End If

	If PLAYERrezscale>3
		gridpoint.pull(PLAYERx-GRIDxoff,PLAYERy-GRIDyoff,(5+32)/3)
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Move Player
'////////////////////////////////////////////////////////////////////////////////
Function	MovePlayer()
	Select	PLAYERinputtype
		Case	0
			DoPlayerMouseKeys()
		Case	1
			DoPlayerXbox360()
		Case	2
			DoPlayerKeysDouble()
		Case	3
			DoPlayer4Button
	End Select

	If PLAYERshield>0
		PLAYERshield:-1
		If PLAYERshield<100
			AddImage(GFXplayershield,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,192,192,(0.5+(Sin(PLAYERshield*15)*0.5)),0,1,1,lightBLEND)
			If (PLAYERshield & 15)=0
				AddSFX(cSFXplayershield,-1)
			End If
		Else
			AddImage(GFXplayershield,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,192,192,(0.75+(Sin(PLAYERshield*10)*0.25)),0,1,1,lightBLEND)
		End If
		If (PLAYERshield & 15)=>8
			gridpoint.shockwave(PLAYERx-GRIDxoff,PLAYERy-GRIDyoff)
		End If
	End If

	AddImage(GFXplayer,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,255,255,255,1,PLAYERang,1,1,lightBLEND)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Player Fire
'////////////////////////////////////////////////////////////////////////////////
Function	PlayerFire()
	Local	bull:tBULLET
	Local	i:Int
	Local	offset:Float

	PLAYERshottime=0

	Select	PLAYERpowerup
		Case	0
			If PLAYERnextshot=0
				bull:tBULLET = New tBULLET
				bull.t=0
				bull.ang=(ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)+180)
				bull.rot=(ATan2(PLAYERy-SIGHTy,PLAYERx-SIGHTx)-90)
				bull.speed=(PLAYERMAXACCEL*3)	'**** Need to rethink this.
				bull.collrad=12
				bull.x=(PLAYERx+Sin(bull.ang+25)*bull.collrad)
				bull.y=(PLAYERy+Cos(bull.ang+25)*bull.collrad)
				bull.damage=100
				bull.blend=LIGHTBLEND
				bull.r=255
				bull.g=200
				bull.b=64
				bull.alpha=1
				bull.scale=1
				bull.img=GFXplayerbullet01
				bull.xacc=PLAYERxacc
				bull.yacc=PLAYERyacc
				ListAddLast(bulletlist,bull)

				bull:tBULLET = New tBULLET
				bull.t=0
				bull.ang=(ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)+180)
				bull.rot=(ATan2(PLAYERy-SIGHTy,PLAYERx-SIGHTx)-90)
				bull.speed=(PLAYERMAXACCEL*3)	'**** Need to rethink this.
				bull.collrad=12
				bull.x=(PLAYERx+Sin(bull.ang-25)*bull.collrad)
				bull.y=(PLAYERy+Cos(bull.ang-25)*bull.collrad)
				bull.damage=100
				bull.blend=LIGHTBLEND
				bull.r=255
				bull.g=200
				bull.b=64
				bull.alpha=1
				bull.scale=1
				bull.img=GFXplayerbullet01
				bull.xacc=PLAYERxacc
				bull.yacc=PLAYERyacc
				ListAddLast(bulletlist,bull)

				PLAYERnextshot=PLAYERnextshotreset
				AddSFX(cSFXplayerfire1,-1)
			End If
		Case	1
			If PLAYERnextshot=0
				offset=-8
				For i=0 To 2
					bull:tBULLET = New tBULLET
					bull.t=0
					bull.ang=(ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)+180)+offset
					bull.rot=(ATan2(PLAYERy-SIGHTy,PLAYERx-SIGHTx)-90)+offset
					bull.speed=(PLAYERMAXACCEL*3)	'**** Need to rethink this.
					bull.collrad=12
					If i=1
						bull.x=(PLAYERx+Sin(bull.ang)*(bull.collrad*2))
						bull.y=(PLAYERy+Cos(bull.ang)*(bull.collrad*2))
					Else
						bull.x=(PLAYERx+Sin(bull.ang)*(bull.collrad/2))
						bull.y=(PLAYERy+Cos(bull.ang)*(bull.collrad/2))
					End If
					bull.damage=150
					bull.blend=LIGHTBLEND
					bull.r=255
					bull.g=255
					bull.b=64
					bull.alpha=1
					bull.scale=1
					bull.img=GFXplayerbullet01
					bull.xacc=PLAYERxacc
					bull.yacc=PLAYERyacc
					ListAddLast(bulletlist,bull)
					offset:+8
				Next
				PLAYERnextshot=PLAYERnextshotreset
				AddSFX(cSFXplayerfire2,-1)
			End If
		Case	2
			If PLAYERnextshot=0
				offset=-4
				For i=0 To 4
					bull:tBULLET = New tBULLET
					bull.t=0
					bull.ang=(ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)+180)+offset
					bull.rot=(ATan2(PLAYERy-SIGHTy,PLAYERx-SIGHTx)-90)+offset
					bull.speed=(PLAYERMAXACCEL*3)	'**** Need to rethink this.
					bull.collrad=12
					If offset=-4 Or offset=4
						bull.x=(PLAYERx+Sin(bull.ang)*(bull.collrad))
						bull.y=(PLAYERy+Cos(bull.ang)*(bull.collrad))
					Else
						bull.x=(PLAYERx+Sin(bull.ang)*(bull.collrad+(bull.collrad/2)))
						bull.y=(PLAYERy+Cos(bull.ang)*(bull.collrad+(bull.collrad/2)))
					End If
					bull.damage=200
					bull.blend=LIGHTBLEND
					bull.r=255
					bull.g=128
					bull.b=64
					bull.alpha=1
					bull.scale=1
					bull.img=GFXplayerbullet01
					bull.xacc=PLAYERxacc
					bull.yacc=PLAYERyacc
					ListAddLast(bulletlist,bull)
					offset:+2
				Next

				PLAYERnextshot=PLAYERnextshotreset
				AddSFX(cSFXplayerfire3,-1)
			End If
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Player Check Death
'////////////////////////////////////////////////////////////////////////////////
Function	PlayerCheckDeath()
	Local	n:tNME
	Local	hit:Int
	Local	dis:Float
	Local	j:Int

	hit=0

	For	n:tNME = EachIn nmelist
		If n.mode=1
			dis=Sqr(((PLAYERx-n.x)*(PLAYERx-n.x))+((PLAYERy-n.y)*(PLAYERy-n.y)))
			If dis<(PLAYERcollrad+n.collrad)
				If PLAYERshield=0
					GAMEMODE=3
					PLAYERmode=3
					PLAYERdeathcount=150
					PLAYERrezscale=6
					PLAYERrezalpha=1
					PLAYERrezalpha2=1
					PLAYERang=0
					If hit=0
						n.iamtheone=1
					End If
					hit=1
				Else
					n.mode=2
					n.score=0
					AddSFX(cSFXbombhit,n.x)
				End If
			End If
			If n.t=5
				For j=1 To SNAKETAILLENGTH
					If n.tabx[j*SNAKETAILSTEP]<>-1
						dis=Sqr(((PLAYERx-n.tabx[j*SNAKETAILSTEP])*(PLAYERx-n.tabx[j*SNAKETAILSTEP]))+((PLAYERy-n.taby[j*SNAKETAILSTEP])*(PLAYERy-n.taby[j*SNAKETAILSTEP])))
						If dis<(PLAYERcollrad+8)
							If PLAYERshield=0
								GAMEMODE=3
								PLAYERmode=3
								PLAYERdeathcount=150
								PLAYERrezscale=6
								PLAYERrezalpha=1
								PLAYERrezalpha2=1
								PLAYERang=0
								If hit=0
									n.iamtheone=1
								End If
								hit=1
							End If
						End If
					End If
				Next
			End If
		End If
	Next

	If hit<>0
		For	n:tNME = EachIn nmelist
			n.mode=2
			n.score=0
		Next
		AddSFX(cSFXplayerexp,-1)
		ClearList(BULLETlist)
		PLAYERlifes:-1
		If PLAYERlifes=0
			If GAMEmusicon=1
				StopChannel(SFXingamemusicCH)
				GAMEmusicon=0
			End If
		End If

	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Player Death
'////////////////////////////////////////////////////////////////////////////////
Function	PlayerDeath()
	AddImage(GFXplayerrez04,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,255,255,PLAYERrezalpha2,PLAYERang*2,12-(PLAYERrezscale*2),12-(PLAYERrezscale*2),LIGHTBLEND)

	AddImage(GFXplayerrez05,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,255,192,255,PLAYERrezalpha,PLAYERang*2,6-PLAYERrezscale,6-PLAYERrezscale,LIGHTBLEND)

	AddImage(GFXplayerrez01,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,255,255,PLAYERrezalpha2,PLAYERang,7-PLAYERrezscale,7-PLAYERrezscale,LIGHTBLEND)

	AddImage(GFXplayerrez02,PLAYERx-WINDOWx,PLAYERy-WINDOWy,0,192,255,255,PLAYERrezalpha2,-PLAYERang,7-PLAYERrezscale,7-PLAYERrezscale,LIGHTBLEND)

	PLAYERrezscale:-0.1
	PLAYERrezalpha:-0.0075
	PLAYERrezalpha2:-0.02
	PLAYERang:+1
	PLAYERhasdied=1

	If PLAYERrezscale>3
		gridpoint.pull(PLAYERx-WINleft,PLAYERy-WINtop,(5+32)/3)
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Move Player with Mouse and Keys
'////////////////////////////////////////////////////////////////////////////////
Function	DoPlayerMouseKeys()
	Local	oldx:Float
	Local	oldy:Float

	If KeyDown(CONTROLup)
		If PLAYERyacc>-PLAYERMAXACCEL
			PLAYERyacc:-PLAYERACCEL
		End If
	Else
		If KeyDown(CONTROLdown)
			If PLAYERyacc<PLAYERMAXACCEL
				PLAYERyacc:+PLAYERACCEL
			End If
		Else
			If PLAYERyacc>0
				PLAYERyacc:-PLAYERFRICTION
			Else
				If PLAYERyacc<0
					PLAYERyacc:+PLAYERFRICTION
				End If
			End If
		End If			
	End If
	
	If KeyDown(CONTROLleft)
		If PLAYERxacc>-PLAYERMAXACCEL
			PLAYERxacc:-PLAYERACCEL
		End If
	Else
		If KeyDown(CONTROLright)
			If PLAYERxacc<PLAYERMAXACCEL
				PLAYERxacc:+PLAYERACCEL
			End If
		Else
			If PLAYERxacc>0
				PLAYERxacc:-PLAYERFRICTION
			Else
				If PLAYERxacc<0
					PLAYERxacc:+PLAYERFRICTION
				End If
			End If
		End If			
	End If

	oldx=PLAYERx
	oldy=PLAYERy

	PLAYERx:+PLAYERxacc
	PLAYERy:+PLAYERyacc

	If PLAYERx<(WINleft+PLAYERcollrad)
		PLAYERxacc=0
		PLAYERx=(WINleft+PLAYERcollrad)
	Else
		If PLAYERx>(WINright-PLAYERcollrad)
			PLAYERxacc=0
			PLAYERx=(WINright-PLAYERcollrad)
		End If
	End If

	If PLAYERy<(WINtop+PLAYERcollrad)
		PLAYERyacc=0
		PLAYERy=(WINtop+PLAYERcollrad)
	Else
		If PLAYERy>(WINbot-PLAYERcollrad)
			PLAYERyacc=0
			PLAYERy=(WINbot-PLAYERcollrad)
		End If
	End If

	UpdateWindow()

	SIGHTx=MouseX()+WINDOWx
	SIGHTy=MouseY()+WINDOWy

	If PLAYERx=oldx And PLAYERy=oldy
	Else
		PLAYERang=ATan2(oldy-PLAYERy,oldx-PLAYERx)-90
		PLAYERengang=-PLAYERang'ATan2(oldx-PLAYERx,oldy-PLAYERy)
		DoThrust(Sqr(((oldx-PLAYERx)*(oldx-PLAYERx))+((oldy-PLAYERy)*(oldy-PLAYERy))))
	End If

	'AddImage(GFXplayersight,SIGHTx-WINDOWx,SIGHTy-WINDOWy,0,64,255,64,1,0,1,1,lightBLEND)
	AddImage(GFXplayersight,SIGHTx-WINDOWx,SIGHTy-WINDOWy,0,Rand(128,255),Rand(128,255),Rand(128,255),1,0,1,1,lightBLEND)

	If MouseDown(1)
		PlayerFire()
	End If

	If KeyDown(CONTROLbomb) And PLAYERbombs>0 And BOMBmode=0
		BOMBmode=1
	End If


End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Get Joystick Positons
'////////////////////////////////////////////////////////////////////////////////
Function	JoyGet:Float(i:Int)
	Local	ret:Float

	ret=0

	Select JOYtype[i]
		Case	0
			ret=JoyHat(JOYport[i])/JOYscale[i]
		Case	1
			ret=JoyPitch(JOYport[i])/JOYscale[i]
		Case	2
			ret=JoyR(JOYport[i])/JOYscale[i]
		Case	3
			ret=JoyRoll(JOYport[i])/JOYscale[i]
		Case	4
			ret=JoyU(JOYport[i])/JOYscale[i]
		Case	5
			ret=JoyV(JOYport[i])/JOYscale[i]
		Case	6
			ret=JoyWheel(JOYport[i])/JOYscale[i]
		Case	7
			ret=JoyX(JOYport[i])/JOYscale[i]
		Case	8
			ret=JoyY(JOYport[i])/JOYscale[i]
		Case	9
			ret=JoyYaw(JOYport[i])/JOYscale[i]
		Case	10
			ret=JoyZ(JOYport[i])/JOYscale[i]
	End Select

	Return(ret)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Move Player Xbox360 Controller
'////////////////////////////////////////////////////////////////////////////////
Function	DoPlayerXbox360()
	Local	oldx:Float
	Local	oldy:Float
	Local	jx:Float
	Local	jy:Float
	Local	jr:Float
	Local	ju:Float
	Local	sa:Float
	Local	pla:Float

	jx=(JoyGet(0)*PLAYERMAXACCEL)'x
	jy=(JoyGet(1)*PLAYERMAXACCEL)'y

	ju=(JoyGet(2)*PLAYERMAXACCEL)'x
	jr=(JoyGet(3)*PLAYERMAXACCEL)'y

	If jx > PLAYERMAXACCEL Then jx=PLAYERMAXACCEL
	If jx < -PLAYERMAXACCEL Then jx=-PLAYERMAXACCEL

	If jy > PLAYERMAXACCEL Then jy=PLAYERMAXACCEL
	If jy < -PLAYERMAXACCEL Then jy=-PLAYERMAXACCEL

	If ju > PLAYERMAXACCEL Then ju=PLAYERMAXACCEL
	If ju < -PLAYERMAXACCEL Then ju=-PLAYERMAXACCEL

	If jr > PLAYERMAXACCEL Then jr=PLAYERMAXACCEL
	If jr < -PLAYERMAXACCEL Then jr=-PLAYERMAXACCEL

	If jx>1 Or jx<-1
		PLAYERxacc=jx
	Else
		If PLAYERxacc>PLAYERFRICTION
			PLAYERxacc:-PLAYERFRICTION
		Else
			If PLAYERxacc<-PLAYERFRICTION
				PLAYERxacc:+PLAYERFRICTION
			Else
				PLAYERxacc=0
			End If
		End If
		'PLAYERxacc=0
	End If

	If jy>1 Or jy<-1
		PLAYERyacc=jy
	Else
		If PLAYERyacc>PLAYERFRICTION
			PLAYERyacc:-PLAYERFRICTION
		Else
			If PLAYERyacc<-PLAYERFRICTION
				PLAYERyacc:+PLAYERFRICTION
			Else
				PLAYERyacc=0
			End If
		End If
		'PLAYERyacc=0
	End If

	oldx=PLAYERx
	oldy=PLAYERy

	PLAYERx:+PLAYERxacc
	PLAYERy:+PLAYERyacc

	If PLAYERx<(WINleft+PLAYERcollrad)
		PLAYERxacc=0
		PLAYERx=(WINleft+PLAYERcollrad)
	Else
		If PLAYERx>(WINright-PLAYERcollrad)
			PLAYERxacc=0
			PLAYERx=(WINright-PLAYERcollrad)
		End If
	End If

	If PLAYERy<(WINtop+PLAYERcollrad)
		PLAYERyacc=0
		PLAYERy=(WINtop+PLAYERcollrad)
	Else
		If PLAYERy>(WINbot-PLAYERcollrad)
			PLAYERyacc=0
			PLAYERy=(WINbot-PLAYERcollrad)
		End If
	End If

	UpdateWindow()

	If jr>2 Or jr<-2 Or ju>2 Or ju<-2
		sa=ATan2(0-ju,0-jr)+180
		SIGHTx=PLAYERx+Sin(sa)*8
		SIGHTy=PLAYERy+Cos(sa)*8
		PlayerFire()
	End If

	If PLAYERx=oldx And PLAYERy=oldy
	Else
		pla=ATan2(PLAYERy-oldy,PLAYERx-oldx)+90
		If (pla-PLAYERang)>180
			pla:-360
		Else
			If (pla-PLAYERang)<-180
				pla:+360
			End If
		End If

		If pla>(PLAYERang)
			PLAYERang:+(pla-PLAYERang)/4
			PLAYERang=(PLAYERang Mod 360)
		Else
			If pla<(PLAYERang)
				PLAYERang:-(PLAYERang-pla)/4
				PLAYERang=(PLAYERang Mod 360)
			End If
		End If
		PLAYERengang= -PLAYERang
		DoThrust(Sqr(((oldx-PLAYERx)*(oldx-PLAYERx))+((oldy-PLAYERy)*(oldy-PLAYERy))))
	End If

	'If JOYbombtype=0
	If JOYinputtype[4]=0
		If (JoyGet(4)<-0.2 Or JoyGet(4)>0.2) And PLAYERbombs>0 And BOMBmode=0
			BOMBmode=1
		End If
	Else
		If JoyDown(JOYtype[4],JOYport[4]) And PLAYERbombs>0 And BOMBmode=0
			BOMBmode=1
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Move Player with Keys only. SHOOT WITH NUMBERPAD.
'////////////////////////////////////////////////////////////////////////////////
Function	DoPlayerKeysDouble()
	Local	oldx:Float
	Local	oldy:Float
	Local	sx:Float
	Local	sy:Float
	Local	fire:Int
	Local	pla:Float

	If KeyDown(CONTROLup)
		If PLAYERyacc>-PLAYERMAXACCEL
			PLAYERyacc:-PLAYERACCEL
		End If
	Else
		If KeyDown(CONTROLdown)
			If PLAYERyacc<PLAYERMAXACCEL
				PLAYERyacc:+PLAYERACCEL
			End If
		Else
			If PLAYERyacc>0
				PLAYERyacc:-PLAYERFRICTION
			Else
				If PLAYERyacc<0
					PLAYERyacc:+PLAYERFRICTION
				End If
			End If
		End If			
	End If
	
	If KeyDown(CONTROLleft)
		If PLAYERxacc>-PLAYERMAXACCEL
			PLAYERxacc:-PLAYERACCEL
		End If
	Else
		If KeyDown(CONTROLright)
			If PLAYERxacc<PLAYERMAXACCEL
				PLAYERxacc:+PLAYERACCEL
			End If
		Else
			If PLAYERxacc>0
				PLAYERxacc:-PLAYERFRICTION
			Else
				If PLAYERxacc<0
					PLAYERxacc:+PLAYERFRICTION
				End If
			End If
		End If			
	End If

	oldx=PLAYERx
	oldy=PLAYERy

	PLAYERx:+PLAYERxacc
	PLAYERy:+PLAYERyacc

	If PLAYERx<(WINleft+PLAYERcollrad)
		PLAYERxacc=0
		PLAYERx=(WINleft+PLAYERcollrad)
	Else
		If PLAYERx>(WINright-PLAYERcollrad)
			PLAYERxacc=0
			PLAYERx=(WINright-PLAYERcollrad)
		End If
	End If

	If PLAYERy<(WINtop+PLAYERcollrad)
		PLAYERyacc=0
		PLAYERy=(WINtop+PLAYERcollrad)
	Else
		If PLAYERy>(WINbot-PLAYERcollrad)
			PLAYERyacc=0
			PLAYERy=(WINbot-PLAYERcollrad)
		End If
	End If

	UpdateWindow()

	If PLAYERx=oldx And PLAYERy=oldy
	Else
		PLAYERang=ATan2(oldy-PLAYERy,oldx-PLAYERx)-90
		PLAYERengang=-PLAYERang'ATan2(oldx-PLAYERx,oldy-PLAYERy)
		DoThrust(Sqr(((oldx-PLAYERx)*(oldx-PLAYERx))+((oldy-PLAYERy)*(oldy-PLAYERy))))
	End If

	fire=0
	SIGHTx=PLAYERx
	SIGHTy=PLAYERy
	If KeyDown(CONTROLup2)	'UP
		SIGHTy:-16
		fire=1
	Else
		If KeyDown(CONTROLdown2)	'DOWN
			SIGHTy:+16
			fire=1
		End If
	End If

	If KeyDown(CONTROLleft2)	'LEFT
		SIGHTx:-16
		fire=1
	Else
		If KeyDown(CONTROLright2)	'RIGHT
			SIGHTx:+16
			fire=1
		End If
	End If

	If fire=1
		pla=ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)+180
		If (pla-SIGHTa)>180
			pla:-360
		Else
			If (pla-SIGHTa)<-180
				pla:+360
			End If
		End If

		If pla>(SIGHTa)
			SIGHTa:+(pla-SIGHTa)/4
			SIGHTa=(SIGHTa Mod 360)
		Else
			If pla<(SIGHTa)
				SIGHTa:-(SIGHTa-pla)/4
				SIGHTa=(SIGHTa Mod 360)
			End If
		End If
		SIGHTx=PLAYERx+Sin(SIGHTa)*16
		SIGHTy=PLAYERy+Cos(SIGHTa)*16
		PlayerFire()
	End If

	If KeyDown(CONTROLbomb) And PLAYERbombs>0 And BOMBmode=0
		BOMBmode=1
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Move Player Joystick 4 Button Fire
'////////////////////////////////////////////////////////////////////////////////
Function	DoPlayer4Button()
	Local	oldx:Float
	Local	oldy:Float
	Local	jx:Float
	Local	jy:Float
	Local	jr:Float
	Local	ju:Float
	Local	sa:Float
	Local	pla:Float
	Local	sla:Float
	Local	fire:Int
	Local	soldx:Float
	Local	soldy:Float

	jx=(JoyGet(0)*PLAYERMAXACCEL)'x
	jy=(JoyGet(1)*PLAYERMAXACCEL)'y

	If jx > PLAYERMAXACCEL Then jx=PLAYERMAXACCEL
	If jx < -PLAYERMAXACCEL Then jx=-PLAYERMAXACCEL

	If jy > PLAYERMAXACCEL Then jy=PLAYERMAXACCEL
	If jy < -PLAYERMAXACCEL Then jy=-PLAYERMAXACCEL

	If jx>1 Or jx<-1
		PLAYERxacc=jx
	Else
		If PLAYERxacc>PLAYERFRICTION
			PLAYERxacc:-PLAYERFRICTION
		Else
			If PLAYERxacc<-PLAYERFRICTION
				PLAYERxacc:+PLAYERFRICTION
			Else
				PLAYERxacc=0
			End If
		End If
		'PLAYERxacc=0
	End If

	If jy>1 Or jy<-1
		PLAYERyacc=jy
	Else
		If PLAYERyacc>PLAYERFRICTION
			PLAYERyacc:-PLAYERFRICTION
		Else
			If PLAYERyacc<-PLAYERFRICTION
				PLAYERyacc:+PLAYERFRICTION
			Else
				PLAYERyacc=0
			End If
		End If
		'PLAYERyacc=0
	End If

	oldx=PLAYERx
	oldy=PLAYERy

	PLAYERx:+PLAYERxacc
	PLAYERy:+PLAYERyacc

	If PLAYERx<(WINleft+PLAYERcollrad)
		PLAYERxacc=0
		PLAYERx=(WINleft+PLAYERcollrad)
	Else
		If PLAYERx>(WINright-PLAYERcollrad)
			PLAYERxacc=0
			PLAYERx=(WINright-PLAYERcollrad)
		End If
	End If

	If PLAYERy<(WINtop+PLAYERcollrad)
		PLAYERyacc=0
		PLAYERy=(WINtop+PLAYERcollrad)
	Else
		If PLAYERy>(WINbot-PLAYERcollrad)
			PLAYERyacc=0
			PLAYERy=(WINbot-PLAYERcollrad)
		End If
	End If

	UpdateWindow()

	fire=0
	SIGHTx=PLAYERx
	SIGHTy=PLAYERy
	If JoyDown(JOY4firebutton[0],JOY4fireport[0])	'UP
		SIGHTy:-16
		fire=1
	Else
		If JoyDown(JOY4firebutton[1],JOY4fireport[1])	'DOWN
			SIGHTy:+16
			fire=1
		End If
	End If

	If JoyDown(JOY4firebutton[2],JOY4fireport[2])	'LEFT
		SIGHTx:-16
		fire=1
	Else
		If JoyDown(JOY4firebutton[3],JOY4fireport[3])	'RIGHT
			SIGHTx:+16
			fire=1
		End If
	End If

	If fire=1
		pla=ATan2(PLAYERx-SIGHTx,PLAYERy-SIGHTy)+180
		If (pla-SIGHTa)>180
			pla:-360
		Else
			If (pla-SIGHTa)<-180
				pla:+360
			End If
		End If

		If pla>(SIGHTa)
			SIGHTa:+(pla-SIGHTa)/4
			SIGHTa=(SIGHTa Mod 360)
		Else
			If pla<(SIGHTa)
				SIGHTa:-(SIGHTa-pla)/4
				SIGHTa=(SIGHTa Mod 360)
			End If
		End If
		SIGHTx=PLAYERx+Sin(SIGHTa)*16
		SIGHTy=PLAYERy+Cos(SIGHTa)*16
		PlayerFire()
	End If


	If PLAYERx=oldx And PLAYERy=oldy
	Else
		pla=ATan2(PLAYERy-oldy,PLAYERx-oldx)+90
		If (pla-PLAYERang)>180
			pla:-360
		Else
			If (pla-PLAYERang)<-180
				pla:+360
			End If
		End If

		If pla>(PLAYERang)
			PLAYERang:+(pla-PLAYERang)/4
			PLAYERang=(PLAYERang Mod 360)
		Else
			If pla<(PLAYERang)
				PLAYERang:-(PLAYERang-pla)/4
				PLAYERang=(PLAYERang Mod 360)
			End If
		End If
		PLAYERengang= -PLAYERang
		DoThrust(Sqr(((oldx-PLAYERx)*(oldx-PLAYERx))+((oldy-PLAYERy)*(oldy-PLAYERy))))
	End If

	If JOYinputtype[4]=0
		If (JoyGet(4)<-0.2 Or JoyGet(4)>0.2) And PLAYERbombs>0 And BOMBmode=0
			BOMBmode=1
		End If
	Else
		If JoyDown(JOYtype[4],JOYport[4]) And PLAYERbombs>0 And BOMBmode=0
			BOMBmode=1
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Player Thrust
'////////////////////////////////////////////////////////////////////////////////
Function	DoThrust(thrust:Float)
	Local	part:tPART
	Local	j:Int

	part:tPART = New tPART
	part.t=1
	part.accel=thrust/2
	part.accelchange=-(part.accel/25)
	part.ang=PLAYERengang+Rand(-40,40)
	part.angchange=0
	part.x=(PLAYERx+Sin(PLAYERengang)*(PLAYERcollrad+8))
	part.y=(PLAYERy+Cos(PLAYERengang)*(PLAYERcollrad+8))
	part.rot= PLAYERang
	part.rotchange=0
	part.alpha=1
	part.alphachange=-0.04
	part.xscale=2
	part.yscale=Rnd(1,2)
	part.xscalechange=0
	part.yscalechange=0.25
	part.img=GFXthrust01
	part.blend=LIGHTBLEND
	part.r=Rand(192,256)
	part.g=Rand(128,256)
	part.b=Rand(64,128)
	part.collrad=8
	part.rcolchange=-8
	part.gcolchange=-16
	part.bcolchange=0
	ListAddLast(particlelist,part)
End Function
