'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	SFXretroload:TSound
Global	SFXretroloadCH:TChannel
Global	SFXretrovoice:TSound
Global	SFXretrovoiceCH:TChannel

Global	GFXretroarc:timage
Global	GFXretroarcmask:timage
Global	GFXretrospec:timage
Global	GFXretrotext:timage

Global	RETROretroalpha:Float=0
Global	RETROretroalpha2:Float=255+128
Global	RETROmode:Int=0
Global	RETROdown:Int=1
Global	RETROsp1:Int=0
Global	RETROsp2:Int=0
Global	RETROmaskx:Float=64
Global	RETROtextalpha:Float=0
'////////////////////////////////////////////////////////////////////////////////
'//	Do Retrospec
'////////////////////////////////////////////////////////////////////////////////
Function	DoRetrospec(ret:Int)
	ClearList(DRAWlist)

	Select RETROmode
		Case	0
			RETROdrawretro()
		Case	1
			RETROdrawarc()
		Case	2
			RETROdrawtext()
		Case	3
			RETROfade()
		Case	4
			MODE=ret
	End Select

	If (AnyKey()=1 Or AnyJoy()=1 Or MouseDown(1) Or MouseDown(2)) And RETROmode<3
		If RETROdown=0
			RETROmode=3
			RETROdown=1
		End If
	Else
		RETROdown=0
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Retrospec
'////////////////////////////////////////////////////////////////////////////////
Function	RETROdrawretro()
	AddImage(GFXretrospec,(GFXw/2)+12,(GFXh/2),0,RETROretroalpha,RETROretroalpha,RETROretroalpha,1)

	RETROretroalpha:+1.5
	If RETROretroalpha>255
		RETROmode=1
	End If

	If RETROsp1=0
		SFXretroloadCH=PlaySound(SFXretroload)
		RETROsp1=1
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Retrospec
'////////////////////////////////////////////////////////////////////////////////
Function	RETROdrawarc()
	AddImage(GFXretroarc,(GFXw/2)-72,(GFXh/2)+8,0,255,255,255,1)
	AddImage(GFXretroarcmask,((GFXw/2)-72)+RETROmaskx,(GFXh/2)+8,0,255,255,255,1,0,2,1,shadeBLEND)
	AddImage(GFXretrospec,(GFXw/2)+12,(GFXh/2),0,RETROretroalpha,RETROretroalpha,RETROretroalpha,1)

	RETROmaskx:-15
	If RETROmaskx<-128
		RETROmode=2
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Retrospec
'////////////////////////////////////////////////////////////////////////////////
Function	RETROdrawtext()
	AddImage(GFXretroarc,(GFXw/2)-72,(GFXh/2)+8,0,255,255,255,1)
	AddImage(GFXretrospec,(GFXw/2)+12,(GFXh/2),0,RETROretroalpha,RETROretroalpha,RETROretroalpha,1)

	AddImage(GFXretrotext,(GFXw/2)+12,(GFXh/2)+24,0,255,255,255,RETROtextalpha)

	RETROtextalpha:+0.01
	If RETROtextalpha>1.0
		RETROmode=3
	End If

	If RETROsp2=0
		SFXretrovoiceCH=PlaySound(SFXretrovoice)
		RETROsp2=1
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Retrospec
'////////////////////////////////////////////////////////////////////////////////
Function	RETROfade()
	AddImage(GFXretroarc,(GFXw/2)-72,(GFXh/2)+8,0,RETROretroalpha2,RETROretroalpha2,RETROretroalpha2,1)
	AddImage(GFXretrospec,(GFXw/2)+12,(GFXh/2),0,RETROretroalpha2,RETROretroalpha2,RETROretroalpha2,1)
	AddImage(GFXretrotext,(GFXw/2)+12,(GFXh/2)+24,0,RETROretroalpha2,RETROretroalpha2,RETROretroalpha2,1)

	RETROretroalpha2:-4
	If RETROretroalpha2<0
		RETROmode=4
	End If

	If SFXretroloadCH<>Null
		StopChannel(SFXretroloadCH)
	End If
	If SFXretrovoiceCH<>Null
		StopChannel(SFXretrovoiceCH)
	End If

End Function
