'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Const	AWDPANSY:Int=0
Const	AWDSUCKER:Int=1
Const	AWDPACIFIST:Int=2
Const	AWD100000:Int=3
Const	AWD250000:Int=4
Const	AWD500000:Int=5
Const	AWD1000000:Int=6
Const	AWDSUR100000:Int=7
Const	AWDSUR250000:Int=8
Const	AWDSUR500000:Int=9
Const	AWDSUR1000000:Int=10
Const	AWDQUATERMASTER:Int=11
Const	AWDSKILL:Int=12
Const	AWDMULTI:Int=13

Global	GFXscore:TImage
Global	GFXscorehigh:TImage
Global	GFXscorenumos:TImage
Global	GFXscorebomb:TImage
Global	GFXscoremulti:TImage

Global	GFXawardpansy:TImage
Global	GFXawardsucker:TImage
Global	GFXaward100:TImage
Global	GFXaward250:TImage
Global	GFXaward500:TImage
Global	GFXaward1000:TImage
Global	GFXaward100s:TImage
Global	GFXaward250s:TImage
Global	GFXaward500s:TImage
Global	GFXaward1000s:TImage
Global	GFXawardquarter:TImage
Global	GFXawardmulti:TImage
Global	GFXawardskill:TImage
Global	GFXawardpacifist:TImage

Global	SFXmultiply:TSound
Global	SFXextralife:TSound
Global	SFXextrabomb:TSound
Global	SFXaward:TSound

Global	GAMEtimeframes:Long
Global	GAMEtimetenths:Long
Global	GAMEtimesecs:Long
Global	GAMEtimemins:Long
Global	GAMEtimehours:Long

Global	GAMEaward:Int[16]

Type	tSCORESPR
	Field	x:Float
	Field	y:Float
	Field	alpha:Float
	Field	scale:Float
	Field	rot:Float
	Field	blend:Int
	Field	r:Int
	Field	g:Int
	Field	b:Int
	Field	val:Long
End Type
Global SCORESPRlist:TList=CreateList()

Type	tMULTIPLY
	Field	x:Float
	Field	y:Float
	Field	alpha:Float
	Field	scale:Float
	Field	rot:Float
	Field	blend:Int
	Field	r:Int
	Field	g:Int
	Field	b:Int
	Field	frame:Int
End Type
Global MULTIPLYlist:TList=CreateList()

'////////////////////////////////////////////////////////////////////////////////
'//	Draw Score
'////////////////////////////////////////////////////////////////////////////////
Function	DrawScore()
	Local	s$
	Local	g:Int
	Local	i:Int
	Local	x:Int

	If HIGHSCORE<PLAYERscore
		HIGHSCORE=PLAYERscore
	End If

	AddImage(GFXscore,48,16,0,32,255,32,1,0,1,1,LIGHTBLEND)
	AddImage(GFXscorehigh,GFXw-80,16,0,32,255,32,1,0,1,1,LIGHTBLEND)

	s$=FormatScore(PLAYERscore)

	x=24
	For i=0 To Len(s$)-1
		g=Asc(Mid$(s$,i+1,1))-32
		AddImage(GFXfont,x,48,g,32,200,32,1,0,1,1,LIGHTBLEND)
		If g=(44-32)
			x:+6
		Else
			x:+14
		End If
	Next

	s$=FormatScore(HIGHSCORE)

	x=((GFXw+6)-(Len(s$)*14))

	g=Len(s$)
	If g>4 And g<8
		x:+8
	Else
		If g>7 And g<12
			x:+16
		Else
			If g>11
				x:+24
			End If
		End If
	End If

	For i=0 To Len(s$)-1
		g=Asc(Mid$(s$,i+1,1))-32
		AddImage(GFXfont,x,48,g,32,200,32,1,0,1,1,LIGHTBLEND)
		If g=(44-32)
			x:+6
		Else
			x:+14
		End If
	Next

	DrawLifes()
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Format Score
'////////////////////////////////////////////////////////////////////////////////
Function	FormatScore:String(s$)
	Local	lnt:Int

	lnt=Len(s$)
	If lnt>3 And lnt<7
		s$=Left(s$,lnt-3)+","+Right(s$,3)
	Else
		If lnt>6 And lnt<10
			s$=Left(s$,Len(s$)-3)+","+Right(s$,3)
			s$=Left(s$,Len(s$)-7)+","+Right(s$,7)
		Else
			If lnt>9
				s$=Left(s$,Len(s$)-3)+","+Right(s$,3)
				s$=Left(s$,Len(s$)-7)+","+Right(s$,7)
				s$=Left(s$,Len(s$)-11)+","+Right(s$,11)
			End If
		End If
	End If
	Return(s$)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Update Score
'////////////////////////////////////////////////////////////////////////////////
Function	UpdateScore(val:Long,x:Float,y:Float)
	Local	scr:tSCORESPR
	If val<>0
		val:*PLAYERmultiply
		PLAYERscore:+val
		PLAYERshite=1

		If CONFhotscore=1
			scr:tSCORESPR = New tSCORESPR
			scr.x=x
			scr.y=y
			scr.alpha=1.5
			scr.scale=1
			scr.blend=LIGHTBLEND
			scr.rot=0
			scr.r=255
			scr.g=255
			scr.b=0
			scr.val=val
			ListAddLast(scoresprlist,scr)	
		End If
	End If
	CheckMultiply(x,y)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Lifes
'////////////////////////////////////////////////////////////////////////////////
Function	DrawLifes()
	Local	count:Int
	Local	x:Int
	Local	i:Int
	Local	s$
	Local	lnt:Int
	Local	g:Int

	count=PLAYERlifes

	If count<4
		If count>0
			x=((GFXw/2)-(count*32))+16
			For i=0 To count-1
				AddImage(GFXplayer,x+(i*32),18,0,32,255,32,1,0,0.8,0.8,LIGHTBLEND)
			Next
		End If
	Else
		AddImage(GFXplayer,(GFXw/2)-16,18,0,32,255,32,1,0,0.8,0.8,LIGHTBLEND)
		s$=PLAYERlifes
		lnt=Len(s$)*14
		x=((GFXw/2)-14)-lnt
		For i=0 To Len(s$)-1
			g=Asc(Mid$(s$,i+1,1))-32
			AddImage(GFXfont,x-4,22,g,32,200,32,1,0,1,1,LIGHTBLEND)
			x:+14
		Next
	End If

	count=PLAYERbombs

	If count<4
		If count>0
			x=(GFXw/2)+16
			For i=0 To count-1
				AddImage(GFXscorebomb,x+(i*32),18,0,32,255,32,1,0,1,1,LIGHTBLEND)
			Next
		End If
	Else
		AddImage(GFXscorebomb,(GFXw/2)+16,18,0,32,255,32,1,0,1,1,LIGHTBLEND)
		s$=PLAYERbombs
		lnt=Len(s$)-1
		x=(GFXw/2)+52
		For i=0 To lnt
			g=Asc(Mid$(s$,i+1,1))-32
			AddImage(GFXfont,x-4,22,g,32,200,32,1,0,1,1,LIGHTBLEND)
			x:+14
		Next
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Game Time
'////////////////////////////////////////////////////////////////////////////////
Function	UpdateGameTime()
	GAMEtimeframes:+1

	GAMEtimetenths:+1
	If GAMEtimetenths=ReqFPS
		GAMEtimetenths=0
		GAMEtimesecs:+1
		If GAMEtimesecs=60
			GAMEtimesecs=0
			GAMEtimemins:+1
			If GAMEtimemins=60
				GAMEtimemins=0
				GAMEtimehours:+1
				If GAMEtimehours=10
					GAMEtimehours=0
				End If
			End If
		End If
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Time
'////////////////////////////////////////////////////////////////////////////////
Function	DrawGameTime()
Rem 
	Local	s:String

	s$=GAMEtimetenths
	If Len(s$)<2
		s$="0"+s$
	End If
	s$=GAMEtimesecs
	If Len(s$)<2
		s$="0"+s$
	End If
	PrintGame(":"+s$,(GFXw/2)+26,36,0,255,0,0)
	s$=GAMEtimemins
	If Len(s$)<2
		s$="0"+s$
	End If
	PrintGame(":"+s$,(GFXw/2)-8,36,0,255,0,0)
	s$=GAMEtimehours
	If Len(s$)<2
		s$="0"+s$
	End If
	PrintGame(s$,(GFXw/2)-40,36,0,255,0,0)
End Rem
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Hit Score
'////////////////////////////////////////////////////////////////////////////////
Function	DoHitScore()
	Local	i:tSCORESPR
	Local	s$
	Local	count:Int
	Local	ln:Int
	Local	g:Int
	Local	scale:Float

	If CONFhotscore=1
		For	i:tSCORESPR = EachIn scoresprlist
			If i.alpha<0.5
				scale=(i.alpha*2)
			Else
				scale=1
			End If
	
			s$=i.val
			ln=Len(s$)
			ln:-1
			For count=0 To ln
				g=Asc(Mid$(s$,count+1,1))
				g:-48
				AddImage(GFXscorenumos,((i.x-((ln*8)/2))+(count*8))-WINDOWx,i.y-WINDOWy,g,i.r,i.g,i.b,i.alpha,i.rot,scale,scale,i.blend)
			Next
	
			i.alpha:-0.05
			If i.alpha<0
				scoresprlist.remove i
			End If
		Next
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Check Multiplyer
'////////////////////////////////////////////////////////////////////////////////
Function	CheckMultiply(x:Float,y:Float)
	Local	mul:tMULTIPLY
	Local	nme:Int
	Local	old:Int

	If debugTOTALKILLEDNODEATH>=PLAYERmultiplydelta
		If PLAYERmultiply<10
			mul:tMULTIPLY = New tMULTIPLY
			mul.x=x
			mul.y=y
			mul.alpha=3
			mul.scale=1
			mul.blend=LIGHTBLEND
			mul.rot=0
			mul.r=200
			mul.g=200
			mul.b=200
			mul.frame=(PLAYERmultiply-1)
			ListAddLast(MULTIPLYlist,mul)

			PLAYERmultiply:+1
			PLAYERmultiplydelta=PLAYERmultiplydelta+(PLAYERmultiplydelta*2)
			AddSFX(cSFXmultiply,x)

			If GAMEaward[AWDMULTI]=0
				If PLAYERmultiply=10 
					GAMEaward[AWDMULTI]=1
					AddSFX(cSFXaward,x)
				End If
			End If

		End If
	End If

	If PLAYERscore>=PLAYERlifesdelta
		PLAYERlifes:+1
		PLAYERlifesdelta:+PLAYERlifesdeltaadd
		AddSFX(cSFXextralife,-1)
		If GAMEaward[AWDSKILL]=0
			If PLAYERlifes>=9
				GAMEaward[AWDSKILL]=1
				AddSFX(cSFXaward,-1)
			End If
		End If
	End If

	If PLAYERscore>=PLAYERbombsdelta
		PLAYERbombs:+1
		PLAYERbombsdelta:+PLAYERbombsdeltaadd
		AddSFX(cSFXextrabomb,-1)
		If GAMEaward[AWDQUATERMASTER]=0
			If PLAYERbombs>=9
				GAMEaward[AWDQUATERMASTER]=1
				AddSFX(cSFXaward,-1)
			End If
		End If
	End If

	If PLAYERscore>=PLAYERpowerupdelta
		nme=FindMostKilled()
		old=PLAYERpowerup
		Select nme
			Case	0
				PLAYERpowerup=1
				PLAYERnextshotreset=6
			Case	1
				PLAYERpowerup=2
				PLAYERnextshotreset=7
			Case	2
				PLAYERpowerup=2
				PLAYERnextshotreset=7
			Case	3
				PLAYERpowerup=1
				PLAYERnextshotreset=6
			Case	4
				PLAYERpowerup=1
				PLAYERnextshotreset=6
			Case	5
				PLAYERpowerup=2
				PLAYERnextshotreset=7
			Case	6
				PLAYERpowerup=1
				PLAYERnextshotreset=6
			Case	7
				PLAYERpowerup=2
				PLAYERnextshotreset=7
			Case	10
				PLAYERpowerup=1
				PLAYERnextshotreset=6
		End Select

		PLAYERpowerupdelta:+PLAYERpowerupdeltaadd

		For nme=0 To 10
			KILLtype[nme]=0
		Next
	End If

	'**** AWARDS

	If GAMEaward[AWD100000]=0
		If PLAYERscore>=100000 
			GAMEaward[AWD100000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWDSUR100000]=0
		If PLAYERscore>=100000 And PLAYERhasdied=0
			GAMEaward[AWDSUR100000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWD250000]=0
		If PLAYERscore>=250000
			GAMEaward[AWD250000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWDSUR250000]=0
		If PLAYERscore>=250000 And PLAYERhasdied=0
			GAMEaward[AWDSUR250000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWD500000]=0
		If PLAYERscore>=500000
			GAMEaward[AWD500000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWDSUR500000]=0
		If PLAYERscore>=500000 And PLAYERhasdied=0
			GAMEaward[AWDSUR500000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWD1000000]=0
		If PLAYERscore>=1000000 
			GAMEaward[AWD1000000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

	If GAMEaward[AWDSUR1000000]=0
		If PLAYERscore>=1000000 And PLAYERhasdied=0
			GAMEaward[AWDSUR1000000]=1
			AddSFX(cSFXaward,-1)
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Find Most Killed NME
'////////////////////////////////////////////////////////////////////////////////
Function	FindMostKilled:Int()
	Local	nme:Int
	Local	done:Int
	Local	i:Int

	nme=-1
	For i=0 To 10
		If KILLtype[i]>nme
			nme=KILLtype[i]
			done=i
		End If
	Next

	Return(done)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Hit Score
'////////////////////////////////////////////////////////////////////////////////
Function	DoMultiply()
	Local	i:tMULTIPLY

	For	i:tMULTIPLY = EachIn MULTIPLYlist
		AddImage(GFXscoremulti,i.x-WINDOWx,i.y-WINDOWy,i.frame,i.r,i.g,i.b,i.alpha,i.rot,i.scale,i.scale,i.blend)

		i.scale:+0.015'0.0125

		i.alpha:-0.05
		If i.alpha<0
			MULTIPLYlist.remove i
		End If
	Next	
End Function

