'////////////////////////////////////////////////////////////////////////////////
'//	Load Graphics
'////////////////////////////////////////////////////////////////////////////////
Global	GFXloadbar:TImage
'////////////////////////////////////////////////////////////////////////////////
'//	Load Graphics
'////////////////////////////////////////////////////////////////////////////////
Function	LoadGraphics()

	AutoImageFlags(FILTEREDIMAGE|MIPMAPPEDIMAGE)

	GFXtitlelogo=LoadImage("data\gfx\titlelogo.png")
	SetColor(0,255,0)
	SetScale(1,1)
	SetRotation(0)
	SetAlpha(1)
	SetBlend(ALPHABLEND)
	DrawImage(GFXtitlelogo,GFXw/2,GFXh/2)
	Flip()
	
	GFXfont=LoadAnimImage("data\gfx\font.png",32,32,0,100)
	GFXfontsmall=LoadAnimImage("data\gfx\fontsmall.png",8,8,0,768,MASKEDIMAGE)

	GFXmenubar01=LoadImage("data\gfx\menubar01.png")
	GFXwhite=LoadImage("data\gfx\white.png")
	GFXwhite2=LoadImage("data\gfx\white2.png")

	GFXscore=LoadImage("data\gfx\score.png")
	GFXscorehigh=LoadImage("data\gfx\scorehigh.png")
	GFXscorenumos=LoadAnimImage("data\gfx\scorenumos.png",8,16,0,10)
	GFXscorebomb=LoadImage("data\gfx\scorebomb.png")
	GFXscoremulti=LoadAnimImage("data\gfx\multiplier.png",152,32,0,9)

	GFXborder01=LoadImage("data\gfx\border01.png")
	GFXborder02=LoadImage("data\gfx\border02.png")
	GFXborder03=LoadImage("data\gfx\border03.png")
	GFXborder04=LoadImage("data\gfx\border04.png")
	GFXborder05=LoadImage("data\gfx\border05.png")
	GFXborder06=LoadImage("data\gfx\border06.png")
	GFXborder07=LoadImage("data\gfx\border07c.png")
	GFXborder08=LoadImage("data\gfx\border08.png")
	GFXborder09=LoadImage("data\gfx\border09.png")

	GFXstar01=LoadImage("data\gfx\star01.png")
	GFXstar02=LoadImage("data\gfx\star02.png")
	GFXstar03=LoadImage("data\gfx\star03.png")

	GFXplayer=LoadImage("data\gfx\player.png")
	GFXplayersight=LoadImage("data\gfx\playersight.png")
	GFXplayershield=LoadImage("data\gfx\playershield.png")
	GFXplayerrez01=LoadImage("data\gfx\playerrez01.png")
	GFXplayerrez02=LoadImage("data\gfx\playerrez02.png")
	GFXplayerrez03=LoadImage("data\gfx\playerrez03.png")
	GFXplayerrez04=LoadImage("data\gfx\playerrez04.png")
	GFXplayerrez05=LoadImage("data\gfx\playerrez05.png",FILTEREDIMAGE)

	GFXthrust01=LoadImage("data\gfx\thrust02.png")

	GFXplayerbomb01=LoadImage("data\gfx\bomb01.png")

	GFXplayerbullet01=LoadImage("data\gfx\playerbullet01.png")

	GFXpart01=LoadImage("data\gfx\part01.png")
	GFXpart02=LoadImage("data\gfx\part02.png")

	GFXnme01=LoadImage("data\gfx\nme01.png")
	GFXnme02=LoadImage("data\gfx\nme02.png")
	GFXnme03=LoadImage("data\gfx\nme03.png")
	GFXnme04=LoadImage("data\gfx\nme04.png")
	GFXnme05=LoadImage("data\gfx\nme05.png")
	GFXnme06=LoadImage("data\gfx\nme06.png")
	GFXnme07=LoadImage("data\gfx\nme07.png")
	GFXnme07b=LoadImage("data\gfx\nme07b.png")
	GFXnme08=LoadImage("data\gfx\nme08.png")
	GFXnme09=LoadImage("data\gfx\nme09.png")
	GFXnme09shield=LoadAnimImage("data\gfx\nme09shield.png",48,48,0,4)
	GFXnme10=LoadImage("data\gfx\nme10.png")
	GFXnme10b=LoadImage("data\gfx\nme10b.png")
	GFXnme10c=LoadImage("data\gfx\nme10c.png")

	GFXpartex01=LoadImage("data\gfx\partex01.png")
	GFXpartex02=LoadImage("data\gfx\partex02.png")

	GFXawardpansy=LoadImage("data\gfx\awdpansy.png")
	GFXawardsucker=LoadImage("data\gfx\awdsucker.png")
	GFXaward100=LoadImage("data\gfx\awd100t.png")
	GFXaward250=LoadImage("data\gfx\awd250t.png")
	GFXaward500=LoadImage("data\gfx\awd500t.png")
	GFXaward1000=LoadImage("data\gfx\awd1000t.png")
	GFXaward100s=LoadImage("data\gfx\awd100c.png")
	GFXaward250s=LoadImage("data\gfx\awd250c.png")
	GFXaward500s=LoadImage("data\gfx\awd500c.png")
	GFXaward1000s=LoadImage("data\gfx\awd1000c.png")
	GFXawardquarter=LoadImage("data\gfx\awdquarter.png")
	GFXawardmulti=LoadImage("data\gfx\awdmulti.png")
	GFXawardskill=LoadImage("data\gfx\awdskill.png")
	GFXawardpacifist=LoadImage("data\gfx\awdnoshoot.png")

	GFXbmlbg=LoadImage("data\gfx\bmlbg.png")
	GFXbmlblitz=LoadImage("data\gfx\bmlblitz.png")
	GFXbmlmax=LoadImage("data\gfx\bmlmax.png")
	GFXbmlline=LoadImage("data\gfx\bmlline.png")
	GFXbmlcover=LoadImage("data\gfx\bmlcover.png")
	GFXbmlshine=LoadImage("data\gfx\bmlshine.png")

	GFXretroarc=LoadImage("data\gfx\retroarc.png")
	GFXretroarcmask=LoadImage("data\gfx\retroarcmask.png")
	GFXretrospec=LoadImage("data\gfx\retrospec.png")
	GFXretrotext=LoadImage("data\gfx\retrotext.png")

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Load Sound
'////////////////////////////////////////////////////////////////////////////////
Function	LoadSounds()
	SFXmenubeep01=LoadSound("data\sfx\menubeep01.ogg")
	SFXmenubeep02=LoadSound("data\sfx\menubeep02.ogg")

	SFXmultiply=LoadSound("data\sfx\multiply.ogg")
	SFXextralife=LoadSound("data\sfx\extralife.ogg")
	SFXextrabomb=LoadSound("data\sfx\extrabomb.ogg")

	SFXplayerfire01=LoadSound("data\sfx\playerfire03.ogg")
	SFXplayerfire02=LoadSound("data\sfx\playerfire02.ogg")
	SFXplayerfire03=LoadSound("data\sfx\playerfire01.ogg")
	SFXplayerexp=LoadSound("data\sfx\playerexp.ogg")
	SFXplayerbomb=LoadSound("data\sfx\bomb.ogg")
	SFXplayerbombhit=LoadSound("data\sfx\bombhit.ogg")
	SFXplayerrez=LoadSound("data\sfx\playerrez.ogg")
	SFXplayershield=LoadSound("data\sfx\shieldwarning.ogg")

	SFXnme01exp=LoadSound("data\sfx\nme01exp.ogg")
	SFXnme01rez=LoadSound("data\sfx\nme01spawn.ogg")
	SFXnme02rez=LoadSound("data\sfx\nme02spawn.ogg")
	SFXnme03rez=LoadSound("data\sfx\nme03spawn.ogg")
	SFXnme04rez=LoadSound("data\sfx\nme04spawn.ogg")
	SFXnme05rez=LoadSound("data\sfx\nme05spawn.ogg")
	SFXnme06rez=LoadSound("data\sfx\nme06spawn.ogg")
	SFXnme07rez=LoadSound("data\sfx\nme07spawn.ogg")
	SFXnme08rez=LoadSound("data\sfx\nme08spawn.ogg")

	SFXaward=LoadSound("data\sfx\award.ogg")

	SFXhole=LoadSound("data\sfx\hole.ogg")
	SFXholeexp=LoadSound("data\sfx\holeexp.ogg")

	SFXtitlemusic=LoadSound("music.ogg",True)
	If SFXtitlemusic=Null
		SFXtitlemusic=LoadSound("data\sfx\titlemusic.ogg",True)
		SFXingamemusic=LoadSound("data\sfx\ingamemusic.ogg",True)
		MUSICtype=0
	Else
		MUSICtype=1
		MUSICon=0
	End If

	SFXbmlsound=LoadSound("data\sfx\bmlsound.ogg",False)

	SFXretroload=LoadSound("data\sfx\retroload.ogg",False)
	SFXretrovoice=LoadSound("data\sfx\retrovoice.ogg",False)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Load All
'////////////////////////////////////////////////////////////////////////////////
Function	LoadAll()
	LoadGraphics()
	LoadSounds()
End Function


