'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	GFXfont:TImage
Global	GFXfontsmall:timage
'Global	FONTwidth:Int[]=[14,5,9,15,13,13,19,6,8,8,13,13,6,14,6,13,14,14,14,14,14,14,14,14,14,14,6,7,10,14,10,14,19,26,26,26,26,26,26,26,25,26,26,26,26,26,26,26,26,26,26,26,25,26,26,26,25,26,8,13,8,11,12,16,14,14,14,14,14,14,14,14,14,5,14,14,14,14,14,14,14,14,14,14,13,14,14,14,14,14,14,11,5,11,11,19,26,1,1,1]Z
Global	FONTwidth:Float[]=[14.0,5.0,9.0,15.0,13.0,13.0,19.0,6.0,8.0,8.0,13.0,13.0,6.0,14.0,6.0,13.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,6.0,7.0,10.0,14.0,10.0,14.0,19.0,26.0,26.0,26.0,26.0,26.0,26.0,26.0,25.0,26.0,26.0,26.0,26.0,26.0,26.0,26.0,26.0,26.0,26.0,26.0,25.0,26.0,26.0,26.0,25.0,26.0,26.0,13.0,16.0,13.0,12.0,16.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,5.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,14.0,13.0,14.0,14.0,14.0,14.0,14.0,14.0,11.0,5.0,11.0,11.0,19.0,26.0,1.0,1.0,1.0]

'////////////////////////////////////////////////////////////////////////////////
'//	Print
'////////////////////////////////////////////////////////////////////////////////
Function	PrintGame(s$,xpos:Int,ypos:Int,r:Int=255,g:Int=255,b:Int=255,center:Int=1,blend:Int=ALPHABLEND,alpha:Float=1,xscale:Float=1,yscale:Float=1)
	Local	lnt:Int
	Local	count:Int
	Local	ch:Int
	Local	total:Int
	Local	ch2:Int

	ypos:+16

	lnt=Len(s$)

	If center=1
		total=0
		For count=0 To lnt-1
			ch=Asc(Mid$(s$,count+1,1))-32
			If ch=(84-32) Or ch=(89-32)	'Check for T V Y
				If count<(lnt-1)
					ch2=Asc(Mid$(s$,count+2,1))-32
					If ch2>(96-32) And ch2<(123-32)
						total:+(16*xscale)
					Else
						total:+(FONTwidth[ch]*xscale)
					End If
				Else
					total:+(FONTwidth[ch]*xscale)
				End If
			Else
				If ch=(86-32)
					If count<(lnt-1)
						ch2=Asc(Mid$(s$,count+2,1))-32
						If ch2>(96-32) And ch2<(123-32)
							total:+(22*xscale)
						Else
							total:+(FONTwidth[ch]*xscale)
						End If
					Else
						total:+(FONTwidth[ch]*xscale)
					End If
				Else
					total:+(FONTwidth[ch]*xscale)	'not T V Y
				End If
			End If
		Next
		xpos=xpos-(total/2)
		xpos:+(16*xscale)
	End If
	'ch=Asc(Left$(s$,1))-32
	'xpos:+(FONTwidth[ch]/2)

	For count=0 To lnt-1
		ch=Asc(Mid$(s$,count+1,1))-32
		If ch<>0
			AddImage(GFXfont,xpos,ypos,ch,r,g,b,alpha,0,xscale,yscale,blend)
		End If

		If ch=(84-32) Or ch=(89-32)	'Check for T V Y
			If count<(lnt-1)
				ch2=Asc(Mid$(s$,count+2,1))-32
				If ch2>(96-32) And ch2<(123-32)
					xpos:+(16*xscale)
				Else
					xpos:+(FONTwidth[ch]*xscale)
				End If
			End If
		Else
			If ch=(86-32)
				If count<(lnt-1)
					ch2=Asc(Mid$(s$,count+2,1))-32
					If ch2>(96-32) And ch2<(123-32)
						xpos:+(22*xscale)
					Else
						xpos:+(FONTwidth[ch]*xscale)
					End If
				End If
			Else
				xpos:+(FONTwidth[ch]*xscale)	'not T V Y
			End If
		End If
	Next
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Print
'////////////////////////////////////////////////////////////////////////////////
Function	GetStringLen:Int(s$)
	Local	lnt:Int
	Local	count:Int
	Local	ch:Int
	Local	total:Int
	Local	ch2:Int

	lnt=Len(s$)

	total=0
	For count=0 To lnt-1
		ch=Asc(Mid$(s$,count+1,1))-32
		If ch=(84-32) Or ch=(89-32)	'Check for T V Y
			If count<(lnt-1)
				ch2=Asc(Mid$(s$,count+2,1))-32
				If ch2>(96-32) And ch2<(123-32)
					total:+16
				Else
					total:+(FONTwidth[ch])
				End If
			Else
				total:+(FONTwidth[ch])
			End If
		Else
			If ch=(86-32)
				If count<(lnt-1)
					ch2=Asc(Mid$(s$,count+2,1))-32
					If ch2>(96-32) And ch2<(123-32)
						total:+22
					Else
						total:+(FONTwidth[ch])
					End If
				Else
					total:+(FONTwidth[ch])
				End If
			Else
				total:+(FONTwidth[ch])	'not T V Y
			End If
		End If
	Next
	Return(total)
End Function


