'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	GFXtitlelogo:TImage
Global	GFXmenubar01:TImage
Global	GFXwhite:TImage
Global	GFXwhite2:TImage

Global	SFXmenubeep01:TSound
Global	SFXmenubeep02:TSound

Global	SFXtitlemusic:TSound
Global	SFXtitlemusicCH:TChannel

Global	QUIT:Int=0
Global	QUITDOWN:Int=0
Global	JOYQUITDOWN:Int=0

Global	TITLEMODE:Int=0
Global	TITLEkeypress:Int
Global	TITLEkeyselect:Int
Global	TITLEmusicon:Int=0
Global	TITLEawardpause:Int
Global	TITLEoldmy:Int
Global	TITLEoldmx:Int
Global	TITLEfwpause:Int=1

Global	TITLEcountreset:Int=(ReqFPS*20)
Global	TITLEcount:Int=TITLEcountreset
Global	TITLEcountnh:Int=0

Global	JOYmax:Int=JoyCount()-1
Global	JOYpressed:Int
Global	JOYvalmin:Float[11,8]
Global	JOYvalmax:Float[11,8]
Global	JOYiguess:Int
Global	JOYiport:Int
Global	JOYiscale:Float
Global	JOYbombselect:Int
Global	JOYbombport:Int

Type	tMENU
	Field	t:Int
	Field	y:Float
	Field	entries:Int
	Field	text:String[16]
	Field	value:Int[16]
	Field	selected:Int
	Field	bary:Int
	Field	bard:Int
	Field	joyd:Int
	Field	joyfd:Int
End Type
Global MENUlist:TList=CreateList()
'////////////////////////////////////////////////////////////////////////////////
'//	AnyKey
'////////////////////////////////////////////////////////////////////////////////
Function	AnyKey:Int()
	Local	i:Int
	Local	hit:Int

	hit=0
	For i=0 To 255
		If KeyDown(i)
			hit=1
		End If
	Next

	Return(hit)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	AnyKey
'////////////////////////////////////////////////////////////////////////////////
Function	AnyKey2:Int()
	Local	i:Int
	Local	hit:Int

	hit=0
	For i=0 To 255
		If KeyDown(i)
			If i<>160 And i<>161 And i<>162 And i<>163 And i<>164 And i<>165 And i<>92	'shift keys
				hit=1
			End If
		End If
	Next

	Return(hit)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Any Joy
'////////////////////////////////////////////////////////////////////////////////
Function	AnyJoy:Int()
	Local	i:Int
	Local	j:Int
	Local	done:Int

	done=0
	For j=0 To JOYmax
		For i=0 To 31
			If JoyDown(i,j)
				done=1
			End If
		Next
	Next
	Return(done)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Load Config
'////////////////////////////////////////////////////////////////////////////////
Function	LoadConfig()
	Local	file:tstream

	file=OpenFile("config.dat",True,False)
	If file=Null
		GFXd=0
		PLAYERINPUTTYPE=0
		CONTROLleft=KEY_A
		CONTROLright=KEY_D
		CONTROLup=KEY_W
		CONTROLdown=KEY_S
		CONTROLleft2=KEY_NUM4
		CONTROLright2=KEY_NUM6
		CONTROLup2=KEY_NUM8
		CONTROLdown2=KEY_NUM5
		CONTROLbomb=KEY_SPACE
		HIGHSCOREentrylastname=""
		JOYtype[0]=7
		JOYtype[1]=8
		JOYtype[2]=4
		JOYtype[3]=2
		JOYtype[4]=10
		JOYtype[5]=7
		'JOYbombtype=0
		'JOYstarttype=1
		JOYinputtype[4]=0				'****
		JOYinputtype[5]=1				'****
		For Local i:Int=0 To 7
			JOYport[i]=0
			JOYscale[i]=1.0
		Next
		MUSICvolume=0.5
		SFXvolume=1
?Win32
		GFXdriver=1
?MacOS
		GFXdriver=0
?
		CONFstars=2
		CONFhotscore=1
		CONFexplosions=2
		CONFgrid=1
		JOY4firebutton[0]=3
		JOY4firebutton[1]=0
		JOY4firebutton[2]=2
		JOY4firebutton[3]=1
		JOY4fireport[0]=0
		JOY4fireport[1]=0
		JOY4fireport[2]=0
		JOY4fireport[3]=0
	Else
		GFXd=Int(ReadByte(file))
		PLAYERINPUTTYPE=Int(ReadByte(file))
		CONTROLleft=Int(ReadByte(file))
		CONTROLright=Int(ReadByte(file))
		CONTROLup=Int(ReadByte(file))
		CONTROLdown=Int(ReadByte(file))
		CONTROLleft2=Int(ReadByte(file))
		CONTROLright2=Int(ReadByte(file))
		CONTROLup2=Int(ReadByte(file))
		CONTROLdown2=Int(ReadByte(file))
		CONTROLbomb=Int(ReadByte(file))
		HIGHSCOREentrylastname=ReadLine(file)
		JOYtype[0]=Int(ReadByte(file))
		JOYtype[1]=Int(ReadByte(file))
		JOYtype[2]=Int(ReadByte(file))
		JOYtype[3]=Int(ReadByte(file))
		JOYtype[4]=Int(ReadByte(file))
		JOYtype[5]=Int(ReadByte(file))
		'JOYbombtype=Int(ReadByte(file))
		'JOYstarttype=Int(ReadByte(file))
		JOYinputtype[4]=Int(ReadByte(file))		'****
		JOYinputtype[5]=Int(ReadByte(file))		'****
		JOYport[0]=Int(ReadByte(file))
		JOYport[1]=Int(ReadByte(file))
		JOYport[2]=Int(ReadByte(file))
		JOYport[3]=Int(ReadByte(file))
		JOYport[4]=Int(ReadByte(file))
		JOYport[5]=Int(ReadByte(file))
		JOYscale[0]=ReadFloat(file)
		JOYscale[1]=ReadFloat(file)
		JOYscale[2]=ReadFloat(file)
		JOYscale[3]=ReadFloat(file)
		JOYscale[4]=ReadFloat(file)
		JOYscale[5]=ReadFloat(file)
		MUSICvolume=ReadFloat(file)
		SFXvolume=ReadFloat(file)
		GFXdriver=Int(ReadByte(file))
		CONFstars=Int(ReadByte(file))
		CONFhotscore=Int(ReadByte(file))
		CONFexplosions=Int(ReadByte(file))
		CONFgrid=Int(ReadByte(file))
		JOY4firebutton[0]=Int(ReadByte(file))
		JOY4firebutton[1]=Int(ReadByte(file))
		JOY4firebutton[2]=Int(ReadByte(file))
		JOY4firebutton[3]=Int(ReadByte(file))
		JOY4fireport[0]=Int(ReadByte(file))
		JOY4fireport[1]=Int(ReadByte(file))
		JOY4fireport[2]=Int(ReadByte(file))
		JOY4fireport[3]=Int(ReadByte(file))
		CloseFile(file)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Save Config
'////////////////////////////////////////////////////////////////////////////////
Function	SaveConfig()
	Local	file:tstream

	file=OpenFile("config.dat",False,True)
	WriteByte(file,Byte(GFXd))
	WriteByte(file,Byte(PLAYERINPUTTYPE))
	WriteByte(file,Byte(CONTROLleft))
	WriteByte(file,Byte(CONTROLright))
	WriteByte(file,Byte(CONTROLup))
	WriteByte(file,Byte(CONTROLdown))
	WriteByte(file,Byte(CONTROLleft2))
	WriteByte(file,Byte(CONTROLright2))
	WriteByte(file,Byte(CONTROLup2))
	WriteByte(file,Byte(CONTROLdown2))
	WriteByte(file,Byte(CONTROLbomb))
	WriteLine(file,HIGHSCOREentrylastname)
	WriteByte(file,Byte(JOYtype[0]))
	WriteByte(file,Byte(JOYtype[1]))
	WriteByte(file,Byte(JOYtype[2]))
	WriteByte(file,Byte(JOYtype[3]))
	WriteByte(file,Byte(JOYtype[4]))
	WriteByte(file,Byte(JOYtype[5]))
	WriteByte(file,Byte(JOYinputtype[4]))
	WriteByte(file,Byte(JOYinputtype[5]))
	WriteByte(file,Byte(JOYport[0]))
	WriteByte(file,Byte(JOYport[1]))
	WriteByte(file,Byte(JOYport[2]))
	WriteByte(file,Byte(JOYport[3]))
	WriteByte(file,Byte(JOYport[4]))
	WriteByte(file,Byte(JOYport[5]))
	WriteFloat(file,JOYscale[0])
	WriteFloat(file,JOYscale[1])
	WriteFloat(file,JOYscale[2])
	WriteFloat(file,JOYscale[3])
	WriteFloat(file,JOYscale[4])
	WriteFloat(file,JOYscale[5])
	WriteFloat(file,MUSICvolume)
	WriteFloat(file,SFXvolume)
	WriteByte(file,Byte(GFXdriver))
	WriteByte(file,Byte(CONFstars))
	WriteByte(file,Byte(CONFhotscore))
	WriteByte(file,Byte(CONFexplosions))
	WriteByte(file,Byte(CONFgrid))
	WriteByte(file,Byte(JOY4firebutton[0]))
	WriteByte(file,Byte(JOY4firebutton[1]))
	WriteByte(file,Byte(JOY4firebutton[2]))
	WriteByte(file,Byte(JOY4firebutton[3]))
	WriteByte(file,Byte(JOY4fireport[0]))
	WriteByte(file,Byte(JOY4fireport[1]))
	WriteByte(file,Byte(JOY4fireport[2]))
	WriteByte(file,Byte(JOY4fireport[3]))
	CloseFile(file)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Title Background
'////////////////////////////////////////////////////////////////////////////////
Function	DoTitleBackground()
	ClearList(DRAWlist)
	ClearSFX()

	DrawStars()

	DoParticles()

	AddImage(GFXtitlelogo,GFXw/2,(GFXh*0.25),0,32,255,32,1,0,1,1,alphaBLEND)
	PrintGame("retro diminished",(GFXw*0.83),(GFXh*0.34),32,255,32,1,ALPHABLEND,1)

	'PrintGame("very work in progress",(GFXw*0.5),(GFXh*0.05),16,192,16,1,ALPHABLEND,1)

	PrintGame(Chr$(127)+" 2006 "+WHOIS+".",GFXw/2,GFXh-48,32,255,32,1,ALPHABLEND,1)
	PrintGame(VERTXT,GFXw*0.95,GFXh-24,32,255,32,1,ALPHABLEND,0.25,0.5,0.5)

	AddImage(GFXplayersight,MouseX(),MouseY(),0,64,255,64,1,0,1,1,alphaBLEND)

	DoMenus()

	TITLEfwpause:-1
	If TITLEfwpause<0
		AddExplosion(Rnd(WINleft,WINright),Rnd(WINtop,WINbot))
		TITLEfwpause=2
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Titles
'////////////////////////////////////////////////////////////////////////////////
Function	DoTitles()
	Select	TITLEMODE
		Case	0
			SetupTitles()
		Case	1
			DoMainMenu()
		Case	2
			QuitAll()
		Case	3
			SetupPlay()
		Case	4
			SetupOptions()
		Case	5
			SetupControlType()
		Case	6
			SetupKeyMouse()
		Case	7
			SetupXbox360()
		Case	8
			SetupDualKeys()
		Case	9
			SetupOptionsBack()
		Case	10
			SetupScreenMode()
		Case	11
			SetupFullScreen16()
		Case	12
			SetupFullScreen24()
		Case	13
			SetupFullScreen32()
		Case	14
			SetupWindowed()
		Case	15
			SetupControls()
		Case	16
			SetupControlsBack()
		Case	17
			SetupRedifineKeys()
		Case	18
			SetupMoveLeft()
		Case	19
			DoMoveInput()
		Case	20
			SetupMoveRight()
		Case	21
			SetupMoveUp()
		Case	22
			SetupMoveDown()
		Case	23
			SetupFireLeft()
		Case	24
			SetupFireRight()
		Case	25
			SetupFireUp()
		Case	26
			SetupFireDown()
		Case	27
			SetupGameSettings()
		'****28-33 Removed
		Case	34
			SetupFireBomb()
		Case	50
			SetupHighscores()
		Case	51
			DisplayHighscores()
		Case	60
			SetupGameOver()
		Case	61
			DisplayGameOver()
		Case	62
			CheckForHighscore()
		Case	65
			DisplayHighscoreEntry()
		Case	70
			SetupAwards()
		Case	71
			DisplayAwards()
		Case	72
			DoneAwards()
		Case	80
			SetupResetHighscore()
		Case	81
			YesResetHighscore()
		Case	82
			NoResetHighscore()
		Case	90
			SetupResetAwards()
		Case	91
			YesResetAwards()
		Case	92
			NoResetAwards()
		Case	100
			SetupConfigJoystick()
		Case	101
			SetupConfigJoystickMovement()
		Case	102
			SetupConfigJoystickMovementWait()
		Case	103
			SetupConfigJoystickMovementLeftRightAssign()
		Case	104
			ConfigJoystickMovementLeftRightAssign()
		Case	105
			SetupConfigJoystickMovementUpDownAssign()
		Case	106
			ConfigJoystickMovementUpDownAssign()
		Case	111
			SetupConfigJoystickFire()
		Case	112
			SetupConfigJoystickFireWait()
		Case	113
			SetupConfigJoystickFireLeftRightAssign()
		Case	114
			ConfigJoystickFireLeftRightAssign()
		Case	115
			SetupConfigJoystickFireUpDownAssign()
		Case	116
			ConfigJoystickFireUpDownAssign()
		Case	121
			SetupConfigJoystickBomb()
		Case	122
			SetupConfigJoystickBombWait()
		Case	123
			SetupConfigJoystickBombAssign()
		Case	124
			ConfigJoystickBombAssign()
		Case	125
			SetupConfigJoystickStart()
		Case	126
			SetupConfigJoystickStartWait()
		Case	127
			SetupConfigJoystickStartAssign()
		Case	128
			ConfigJoystickStartAssign()
		Case	130
			SetupAudio()
		Case	131
			SetupMusicVolume()
		Case	132
			DoMusicVolume()
		Case	133
			SetupSFXVolume()
		Case	134
			DoSFXVolume()
		Case	140
			SetupGFXDriver()
		Case	141
			DoGFXOpengl()
		Case	142
			DoGFXDirectx()
		Case	143
			DoGFXDone()
		Case	150
			SetupCredits()
		Case	151
			DoCredits()
		Case	152
			CreditsDone()
		Case	160
			SetupHighscoreDisplay2()
		Case	161
			DisplayHighscores2()
		Case	170
			SetupStars2()
		Case	171
			StarsOFF()
		Case	172
			StarsMed()
		Case	173
			StarsHigh()
		Case	180
			SetupHitScore()
		Case	181
			HitScoreOFF()
		Case	182
			HitScoreON()
		Case	190
			SetupExplosions2()
		Case	191
			ExplosionsOFF()
		Case	192
			ExplosionsMed()
		Case	193
			ExplosionsHigh()
		Case	200
			SetupGrid2()
		Case	201
			GridOFF()
		Case	202
			GridMed()
		Case	203
			GridHigh()
		Case	210
			SetupJoy4Button()
		Case	220
			SetupConfig4Button()
		Case	221
			SetupConfig4ButtonWait1()
		Case	222
			SetupConfig4ButtonAssign1()
		Case	223
			ConfigJoystick4ButtonAssign1()
		Case	224
			SetupConfig4ButtonAssign2()
		Case	225
			ConfigJoystick4ButtonAssign2()
		Case	226
			SetupConfig4ButtonAssign3()
		Case	227
			ConfigJoystick4ButtonAssign3()
		Case	228
			SetupConfig4ButtonAssign4()
		Case	229
			ConfigJoystick4ButtonAssign4()

	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	DoMenus
'////////////////////////////////////////////////////////////////////////////////
Function	DoMenus()
	Local	i:tMENU
	Local	count:Int
	Local	y:Float
	Local	my:Int
	Local	mx:Int
	Local	jy:Float
	Local	mo:Int

	For	i:tMENU = EachIn MENUlist
		AddImage(GFXwhite2,GFXw/2,i.y,0,2,24,2,0.75,0,8,i.entries+1,ALPHABLEND)

		i.bary:+i.bard
		If i.bary<(i.y-((Float((i.entries+1))/2)*32))
			i.bary=(i.y+((Float((i.entries+1))/2)*32))
		Else
			If i.bary>(i.y+((Float((i.entries+1))/2)*32))
				i.bary=(i.y-((Float((i.entries+1))/2)*32))
			End If
		End If
		AddImage(GFXmenubar01,GFXw/2,i.bary,0,32,255,32,0.125,0,100,4,lightBLEND)

		AddImage(GFXmenubar01,GFXw/2,i.y-((Float((i.entries+1))/2)*32),0,0,255,0,1,0,100,1,ALPHABLEND)
		AddImage(GFXmenubar01,GFXw/2,i.y+((Float((i.entries+1))/2)*32),0,0,255,0,1,0,100,1,ALPHABLEND)
		y=i.y-(((Float(i.entries))/2)*32)+4
		For count=0 To i.entries-1
			If count=i.selected
				PrintGame(i.text[count],GFXw/2,y,255,255,64,1,ALPHABLEND,1)
			Else
				PrintGame(i.text[count],GFXw/2,y,32,192,32,1,ALPHABLEND,1)
			End If
			y:+32
		Next

		If i.t=0
			mo=0
			my=MouseY()
			mx=MouseX()
			y=i.y-(((Float(i.entries)/2)*32)+4)
			If my<>TITLEoldmy
				For count=0 To i.entries-1
					If my>y And my<(y+32)
						If i.selected<>count
							i.selected=count
							AddSFX(cSFXmenumove,-1)
							TITLEcount=TITLEcountreset
						End If
						mo=1
					End If
					y:+32
				Next
			End If

			jy=JoyGet(1)
			If mo=0
				If (jy<-0.5 Or KeyDown(CONTROLup) Or KeyDown(KEY_UP))' And i.selected>0
					If i.joyd=0
						i.selected:-1
						If i.selected<0
							i.selected=(i.entries-1)
						End If
						i.joyd=1
						If i.entries>1
							AddSFX(cSFXmenumove,-1)
						End If
						TITLEcount=TITLEcountreset
					End If
				Else
					If (jy>0.5 Or KeyDown(CONTROLdown) Or KeyDown(KEY_DOWN))' And i.selected<(i.entries-1)
						If i.joyd=0
							i.selected:+1
							If i.selected>(i.entries-1)
								i.selected=0
							End If
							i.joyd=1
							If i.entries>1
								AddSFX(cSFXmenumove,-1)
							End If
							TITLEcount=TITLEcountreset
						End If
					Else
						i.joyd=0
					End If
				End If
			End If

			If JoyDown(0,0) Or JoyDown(0,1) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or MouseDown(1)
				If i.joyfd=0
					i.joyfd=1
					TITLEMODE=i.value[i.selected]
					AddSFX(cSFXmenuaccept,-1)
					MENUlist.Remove(i)
					TITLEcount=TITLEcountreset
				End If
			Else
				i.joyfd=0
			End If

			If mx<>TITLEoldmx
				TITLEcount=TITLEcountreset
			End If
		End If
	Next

	TITLEoldmy=my
	TITLEoldmx=mx
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Titles
'////////////////////////////////////////////////////////////////////////////////
Function	SetupTitles()
	'ShowMouse()

	ClearList(MENUlist)
	ClearList(NMElist)
	ClearList(PARTICLElist)
	ClearList(BULLETlist)
	ClearList(SCORESPRlist)
	ClearList(STARlist)
	ClearSFX()
	SetupStars()
	ResetGrid()

	PLAYERx=(((WINright-WINleft)/2)+WINleft)
	PLAYERy=(((WINbot-WINtop)/2)+WINtop)
	UpdateWindow()

	SetupMenu()

	TITLEMODE=1
	TITLEoldmy=-1

	If MUSICtype=0
		If TITLEmusicon=0
			SFXtitlemusicCH=PlaySound(SFXtitlemusic)
			SetChannelVolume(SFXtitlemusicCH,MUSICvolume)
			TITLEmusicon=1
		End If
	Else
		If MUSICon=0
			MUSICon=1
			SFXtitlemusicCH=PlaySound(SFXtitlemusic)
			SetChannelVolume(SFXtitlemusicCH,MUSICvolume)
		End If
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Main Menu
'////////////////////////////////////////////////////////////////////////////////
Function	DoMainMenu()
	DoTitleBackground()

	TITLEcount:-1
	If TITLEcount<0
		If TITLEcountnh=0
			ClearList(MENUlist)
			SetupHighscoreDisplay2()
			TITLEmode=161
		End If
		TITLEcount=TITLEcountreset
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Menu
'////////////////////////////////////////////////////////////////////////////////
Function	SetupMenu()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=5
	i.text[0]="PLAY"
	i.text[1]="HIGHSCORES"
	i.text[2]="AWARDS"
	i.text[3]="OPTIONS"
	i.text[4]="QUIT"
	i.value[0]=3
	i.value[1]=50
	i.value[2]=70
	i.value[3]=4
	i.value[4]=2
	i.selected=0
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)
	TITLEoldmy=-1
	TITLEcountnh=0
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Quit All
'////////////////////////////////////////////////////////////////////////////////
Function	QuitAll()
	QUIT=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Play
'////////////////////////////////////////////////////////////////////////////////
Function	SetupPlay()
	MODE=1
	GAMEMODE=0
	TITLEMODE=0

	If MUSICtype=0
		If TITLEmusicon=1
			StopChannel(SFXtitlemusicCH)
			TITLEmusicon=0
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Highscores
'////////////////////////////////////////////////////////////////////////////////
Function	SetupHighscores()
	ClearList(MENUlist)
	SetupHighscoreDisplay()
	TITLEMODE=51
	HIGHSCOREfd=1
	HIGHSCOREkd=1
	HIGHSCOREmd=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Options
'////////////////////////////////////////////////////////////////////////////////
Function	SetupOptions()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.7)
	i.entries=6
	i.text[0]="CONTROLS"
	i.text[1]="SCREEN MODE"
	i.text[2]="GAME SETTINGS"
	i.text[3]="AUDIO"
	i.text[4]="CREDITS"
	i.text[5]="back"
	i.value[0]=15
	i.value[1]=10
	i.value[2]=27
	i.value[3]=130
	i.value[4]=150
	i.value[5]=9
	i.selected=5
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Options Back
'////////////////////////////////////////////////////////////////////////////////
Function	SetupOptionsBack()
	TITLEmode=1
	SetupMenu()
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Control Type
'////////////////////////////////////////////////////////////////////////////////
Function	SetupControlType()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=5
	i.text[0]="KEYBOARD & MOUSE"
	i.text[1]="DUAL-STICK JOYSTICK"
	i.text[2]="TWO HANDED KEYBOARD"
	i.text[3]="JOYSTICK 4 BUTTON FIRE"
	i.text[4]="back"
	i.value[0]=6
	i.value[1]=7
	i.value[2]=8
	i.value[3]=210
	i.value[4]=15
	i.selected=PLAYERinputtype
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Key And Mouse
'////////////////////////////////////////////////////////////////////////////////
Function	SetupKeyMouse()
	PLAYERinputtype=0
	SetupControls()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Xbox360
'////////////////////////////////////////////////////////////////////////////////
Function	SetupXbox360()
	PLAYERinputtype=1
	SetupControls()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Dual Keys
'////////////////////////////////////////////////////////////////////////////////
Function	SetupDualKeys()
	PLAYERinputtype=2
	SetupControls()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup JOYSTICK 4 BUTTON FIRE
'////////////////////////////////////////////////////////////////////////////////
Function	SetupJoy4Button()
	PLAYERinputtype=3
	SetupControls()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Screen Mode
'////////////////////////////////////////////////////////////////////////////////
Function	SetupScreenMode()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=5
	i.text[0]="FULLSCREEN 16bit"
	i.text[1]="FULLSCREEN 24bit"
	i.text[2]="FULLSCREEN 32bit"
	i.text[3]="WINDOWED"
	i.text[4]="back"
	i.value[0]=11
	i.value[1]=12
	i.value[2]=13
	i.value[3]=14
	i.value[4]=4
	Select GFXd
		Case	0
			i.selected=3
		Case	16
			i.selected=0
		Case	24
			i.selected=1
		Case	32
			i.selected=2
		Default
			i.selected=4
	End Select
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Windowed
'////////////////////////////////////////////////////////////////////////////////
Function	SetupWindowed()
	GFXd=0
	SetupOptions()
	TITLEmode=1
	EndGraphics()
	Graphics(GFXw,GFXh,GFXd,GFXfps)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Windowed
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFullScreen16()
	GFXd=16
	SetupOptions()
	TITLEmode=1
	EndGraphics()
	Graphics(GFXw,GFXh,GFXd,GFXfps)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Windowed
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFullScreen24()
	GFXd=24
	SetupOptions()
	TITLEmode=1
	EndGraphics()
	Graphics(GFXw,GFXh,GFXd,GFXfps)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup FullScreen
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFullScreen32()
	GFXd=32
	SetupOptions()
	TITLEmode=1
	EndGraphics()
	Graphics(GFXw,GFXh,GFXd,GFXfps)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Control Type
'////////////////////////////////////////////////////////////////////////////////
Function	SetupControls()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=4
	i.text[0]="CONTROL TYPE"
	i.text[1]="REDIFINE KEYS"
	i.text[2]="CONFIGURE JOYSTICK"
	i.text[3]="back"
	i.value[0]=5
	i.value[1]=17
	i.value[2]=100
	i.value[3]=16
	i.selected=3
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Control Type
'////////////////////////////////////////////////////////////////////////////////
Function	SetupControlsBack()
	SetupOptions()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Redifine Keys
'////////////////////////////////////////////////////////////////////////////////
Function	SetupRedifineKeys()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.55)
	i.entries=10
	i.text[0]="MOVE LEFT"
	i.text[1]="MOVE RIGHT"
	i.text[2]="MOVE UP"
	i.text[3]="MOVE DOWN"
	i.text[4]="FIRE LEFT"
	i.text[5]="FIRE RIGHT"
	i.text[6]="FIRE UP"
	i.text[7]="FIRE DOWN"
	i.text[8]="BOMB"
	i.text[9]="back"
	i.value[0]=18
	i.value[1]=20
	i.value[2]=21
	i.value[3]=22
	i.value[4]=23
	i.value[5]=24
	i.value[6]=25
	i.value[7]=26
	i.value[8]=34
	i.value[9]=16
	i.selected=9
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	SetupMoveLeft()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR MOVE LEFT"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=0
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	DoMoveInput()
	Local	i:Int
	DoTitleBackground()

	If AnyKey()=1
		If TITLEkeypress=0
			For i=1 To 255
				If KeyDown(i)
					If i=KEY_ESCAPE
					Else
						Select TITLEkeyselect
							Case	0
								CONTROLleft=i
							Case	1
								CONTROLright=i
							Case	2
								CONTROLup=i
							Case	3
								CONTROLdown=i
							Case	4
								CONTROLleft2=i
							Case	5
								CONTROLright2=i
							Case	6
								CONTROLup2=i
							Case	7
								CONTROLdown2=i
							Case	8
								CONTROLbomb=i
						End Select
					End If
					ClearList(MENUlist)
					SetupRedifineKeys()
					TITLEmode=1
					AddSFX(cSFXmenuaccept,-1)
				End If
			Next
		End If
	Else
		TITLEkeypress=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	SetupMoveRight()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR MOVE RIGHT"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	SetupMoveUp()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR MOVE UP"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=2
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Down
'////////////////////////////////////////////////////////////////////////////////
Function	SetupMoveDown()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR MOVE DOWN"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=3
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFireLeft()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR FIRE LEFT"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=4
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFireRight()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR FIRE RIGHT"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=5
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Left
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFireUp()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR FIRE UP"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=6
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Move Down
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFireDown()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR FIRE DOWN"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=7
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Define Bomb
'////////////////////////////////////////////////////////////////////////////////
Function	SetupFireBomb()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.55)
	i.entries=2
	i.text[0]="PRESS KEY FOR BOMB"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=19
	TITLEkeypress=1
	TITLEkeyselect=8
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Game Settings
'////////////////////////////////////////////////////////////////////////////////
Function	SetupGameSettings()
	Local	i:tMENU
?MacOS
	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.66)
	i.entries=7
	i.text[0]="RESET HIGHSCORES"
	i.text[1]="RESET AWARDS"
	i.text[2]="STARS"
	i.text[3]="HIT SCORE"
	i.text[4]="EXPLOSIONS"
	i.text[5]="GRID"
	i.text[6]="back"
	i.value[0]=80
	i.value[1]=90
	i.value[2]=170
	i.value[3]=180
	i.value[4]=190
	i.value[5]=200
	i.value[6]=16
	i.selected=6
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)
?WIN32
	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.66)
	i.entries=8
	i.text[0]="RESET HIGHSCORES"
	i.text[1]="RESET AWARDS"
	i.text[2]="STARS"
	i.text[3]="HIT SCORE"
	i.text[4]="EXPLOSIONS"
	i.text[5]="GRID"
	i.text[6]="GRAPHICS DRIVER"
	i.text[7]="back"
	i.value[0]=80
	i.value[1]=90
	i.value[2]=170
	i.value[3]=180
	i.value[4]=190
	i.value[5]=200
	i.value[6]=140
	i.value[7]=16
	i.selected=7
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)
?
	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup game Over
'////////////////////////////////////////////////////////////////////////////////
Function	SetupGameOver()
	Local	i:tMENU
	Local	x:Int
	Local	j:Int

	x=0
	For j=0 To 13
		If GAMEaward[j]=1
			x=1
		End If
	Next

	If x=1
		i:tMENU = New tMENU
		i.t=1
		i.y=(GFXh*0.35)
		i.entries=6
		i.text[0]="G A M E   O V E R"
		i.text[1]=" "
		i.text[2]=" "
		i.text[3]="awards "
		i.text[4]=" "
		i.text[5]=" "
		i.text[6]=" "
		i.value[0]=0
		i.value[1]=0
		i.value[2]=0
		i.value[3]=0
		i.value[4]=0
		i.value[5]=0
		i.value[6]=0
		i.selected=-1
		i.bard=2
		i.joyd=1
		i.joyfd=1
		ListAddLast(MENUlist,i)
	Else
		i:tMENU = New tMENU
		i.t=1
		i.y=(GFXh*0.35)
		i.entries=3
		i.text[0]="G A M E   O V E R"
		i.text[1]=" "
		i.text[2]=" "
		i.value[0]=0
		i.value[1]=0
		i.value[2]=0
		i.selected=-1
		i.bard=2
		i.joyd=1
		i.joyfd=1
		ListAddLast(MENUlist,i)
	End If

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.85)
	i.entries=1
	i.text[0]="CONTINUE"
	i.value[0]=62
	i.selected=0
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	ClearList(MULTIPLYlist)
	ClearList(NMElist)
	ClearList(BULLETlist)
	ClearList(PARTICLElist)
	ClearList(SCORESPRlist)

	PLAYERx=(((WINright-WINleft)/2)+WINleft)
	PLAYERy=(((WINbot-WINtop)/2)+WINtop)
	UpdateWindow()

	TITLEmode=61

	TITLEoldmy=-1

	If MUSICtype=0
		If TITLEmusicon=0
			SFXtitlemusicCH=PlaySound(SFXtitlemusic)
			SetChannelVolume(SFXtitlemusicCH,MUSICvolume)
			TITLEmusicon=1
		End If
	End If

	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Display game Over
'////////////////////////////////////////////////////////////////////////////////
Function DisplayGameOver()
	Local	s:String
	Local	awd:timage[]=[GFXawardpansy,GFXawardsucker,GFXawardpacifist,GFXaward100,GFXaward250,GFXaward500,GFXaward1000,GFXaward100s,GFXaward250s,GFXaward500s,GFXaward1000s,GFXawardquarter,GFXawardskill,GFXawardmulti]
	Local	i:Int
	Local	x:Int
	Local	scale:Float
	Local	inc:Int

	ClearList(DRAWlist)
	DrawStars()
	DoMenus()

	scale=1
	inc=80
	x=0
	For i=0 To 13
		If GAMEaward[i]=1
			x:+inc
		End If
	Next
	If x=0
		s$=FormatScore(PLAYERscore)
		PrintGame("final score: "+s$,GFXw/2,GFXh*0.375,32,192,32,1,ALPHABLEND,1)
	Else
		s$=FormatScore(PLAYERscore)
		PrintGame("final score: "+s$,GFXw/2,GFXh*0.3,32,192,32,1,ALPHABLEND,1)
	End If
	If x>=800
		scale=0.5
		inc=56
		x=0
		For i=0 To 13
			If GAMEaward[i]=1
				x:+inc
			End If
		Next
	End If

	If x=0
		'PrintGame("-=NONE=-",GFXw/2,GFXh*0.45,32,192,32,1,ALPHABLEND,1)
	Else
		x=((GFXw-x)/2)+32
		For i=0 To 13
			If GAMEaward[i]=1
				AddImage(awd[i],x,GFXh*0.45,0,32,255,32,1,0,scale,scale,alphaBLEND)
				x:+inc
			End If
		Next
	End If

	AddImage(GFXplayersight,MouseX(),MouseY(),0,64,255,64,1,0,1,1,alphaBLEND)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Check for high score
'////////////////////////////////////////////////////////////////////////////////
Function CheckForHighScore()
	Local	i:Int

	ClearList(MENUlist)
	If HIGHSCOREtablelastscorepos<>-1
		SetupHighscoreEntry()
		TITLEMODE=65
		HIGHSCOREfd=1
		HIGHSCOREkd=1
		HIGHSCOREmd=1
		HIGHSCOREentrycurdone=0
		HIGHSCOREentry=""
		If HIGHSCOREentrylastname<>""
			HIGHSCOREentry=HIGHSCOREentrylastname
		End If
	Else
		MODE=0
		SetupMenu()
		TITLEMODE=1
	End If

	For i=0 To 15
		If GAMEaward[i]<>0
			PLAYERachievments[i]=1
		End If
	Next

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Awards
'////////////////////////////////////////////////////////////////////////////////
Function SetupAwards()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.875)
	i.entries=1
	i.text[0]="back"
	i.value[0]=72
	i.selected=0
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=71
	TITLEawardpause=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Display Awards
'////////////////////////////////////////////////////////////////////////////////
Function DisplayAwards()
	Local	i:Int
	Local	part:tPART
	Local	mx:Float
	Local	my:Float
	Local	mr:Float
	Local	r:Int
	Local	g:Int
	Local	b:Int

	ClearList(DRAWlist)
	ClearSFX()
	DrawStars()
	DoParticles()
	DoMenus()

	PrintGame("A W A R D S",(GFXw/2),(GFXw*0.025),32,255,32,1,ALPHABLEND,1,1,1)

	If PLAYERachievments[0]=0
'		AddImage(GFXawardpansy,(GFXw*0.3),(GFXh*0.175),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXawardpansy,(GFXw*0.3),(GFXh*0.175),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[1]=0
'		AddImage(GFXawardsucker,(GFXw*0.5),(GFXh*0.175),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXawardsucker,(GFXw*0.5),(GFXh*0.175),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[2]=0
'		AddImage(GFXawardpacifist,(GFXw*0.7),(GFXh*0.175),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXawardpacifist,(GFXw*0.7),(GFXh*0.175),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If

	If PLAYERachievments[3]=0
'		AddImage(GFXaward100,(GFXw*0.2),(GFXh*0.325),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward100,(GFXw*0.2),(GFXh*0.325),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[4]=0
'		AddImage(GFXaward250,(GFXw*0.4),(GFXh*0.325),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward250,(GFXw*0.4),(GFXh*0.325),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[5]=0
'		AddImage(GFXaward500,(GFXw*0.6),(GFXh*0.325),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward500,(GFXw*0.6),(GFXh*0.325),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[6]=0
'		AddImage(GFXaward1000,(GFXw*0.8),(GFXh*0.325),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward1000,(GFXw*0.8),(GFXh*0.325),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If

	If PLAYERachievments[7]=0
'		AddImage(GFXaward100s,(GFXw*0.2),(GFXh*0.475),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward100s,(GFXw*0.2),(GFXh*0.475),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[8]=0
'		AddImage(GFXaward250s,(GFXw*0.4),(GFXh*0.475),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward250s,(GFXw*0.4),(GFXh*0.475),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[9]=0
'		AddImage(GFXaward500s,(GFXw*0.6),(GFXh*0.475),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward500s,(GFXw*0.6),(GFXh*0.475),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[10]=0
'		AddImage(GFXaward1000s,(GFXw*0.8),(GFXh*0.475),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXaward1000s,(GFXw*0.8),(GFXh*0.475),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If

	If PLAYERachievments[11]=0
'		AddImage(GFXawardquarter,(GFXw*0.3),(GFXh*0.625),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXawardquarter,(GFXw*0.3),(GFXh*0.625),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[12]=0
'		AddImage(GFXawardskill,(GFXw*0.5),(GFXh*0.625),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXawardskill,(GFXw*0.5),(GFXh*0.625),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If
	If PLAYERachievments[13]=0
'		AddImage(GFXawardmulti,(GFXw*0.7),(GFXh*0.625),0,8,8,8,1,0,1,1,ALPHABLEND)
	Else
		AddImage(GFXawardmulti,(GFXw*0.7),(GFXh*0.625),0,32,255,32,1,0,1,1,ALPHABLEND)
	End If

	AddImage(GFXplayersight,MouseX(),MouseY(),0,64,255,64,1,0,1,1,alphaBLEND)

Rem
	TITLEawardpause:-1
	If TITLEawardpause=0
		TITLEawardpause=4
		mx=Rand(WINleft+100,WINright-100)
		my=Rand(WINtop+100,WINbot-100)

		r=Rand(64,255)
		g=Rand(64,255)
		b=Rand(64,255)

		For i=0 To 31
			part:tPART = New tPART
			part.t=1
			part.accel=2+Rand(1,4)
			part.accelchange=0.05'-(part.accel/25)
			part.ang=Rand(0,359)
			part.angchange=0

			mr=Rand(8,16)
			part.x=(mx+Sin(part.ang)*mr)
			part.y=(my+Cos(part.ang)*mr)

			part.rot= (-part.ang)+180
			part.rotchange=0
			part.alpha=1
			part.alphachange=-0.03
			part.xscale=1
			part.yscale=Rnd(1,2)
			part.xscalechange=0
			part.yscalechange=-0.01
			part.img=GFXpart01
			part.blend=LIGHTBLEND
			part.r=r'Rand(64,255)
			part.g=g'Rand(64,255)
			part.b=b'Rand(64,255)
			part.collrad=8
			ListAddLast(particlelist,part)
		Next
	End If
End Rem
	TITLEfwpause:-1
	If TITLEfwpause<0
		AddExplosion(Rnd(WINleft,WINright),Rnd(WINtop,WINbot))
		TITLEfwpause=2
	End If

	If KeyDown(KEY_ESCAPE)
		ClearList(MENUlist)
		MODE=0
		SetupMenu()
		TITLEMODE=1
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Done Awards
'////////////////////////////////////////////////////////////////////////////////
Function DoneAwards()
	MODE=0
	SetupMenu()
	TITLEMODE=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Reset Highscore
'////////////////////////////////////////////////////////////////////////////////
Function SetupResetHighscore()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.5)
	i.entries=2
	i.text[0]="ARE YOU SURE?"
	i.text[1]="this will completely erase all your scores"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.8)
	i.entries=2
	i.text[0]="YES"
	i.text[1]="NO"
	i.value[0]=81
	i.value[1]=82
	i.selected=1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Reset Highscore
'////////////////////////////////////////////////////////////////////////////////
Function YesResetHighscore()
	Local	i:Int

	For i=0 To 99
		HIGHSCOREtablenames[i]="Empty"
		HIGHSCOREtablescores[i]=0
	Next

	ClearList(MENUlist)

	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Reset Highscore
'////////////////////////////////////////////////////////////////////////////////
Function NoResetHighscore()
	ClearList(MENUlist)
	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Reset Highscore
'////////////////////////////////////////////////////////////////////////////////
Function SetupResetAwards()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.5)
	i.entries=2
	i.text[0]="ARE YOU SURE?"
	i.text[1]="this will completely erase all your awards"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.8)
	i.entries=2
	i.text[0]="YES"
	i.text[1]="NO"
	i.value[0]=91
	i.value[1]=92
	i.selected=1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Reset Highscore
'////////////////////////////////////////////////////////////////////////////////
Function YesResetAwards()
	Local	i:Int

	For i=0 To 13
		PLAYERachievments[i]=0
	Next

	ClearList(MENUlist)

	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Reset Highscore
'////////////////////////////////////////////////////////////////////////////////
Function NoResetAwards()
	ClearList(MENUlist)
	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Make Control Guess
'////////////////////////////////////////////////////////////////////////////////
Function	MakeGuess()
	Local	i:Int
	Local	j:Int
	Local	choice:Int
	Local	val:Float
	Local	oldval:Float
	Local	port:Int
	Local	scale:Float

	choice=-1
	oldval=0
	For j=0 To JOYmax
		For i=0 To 10
			val=(JOYvalmax[i,j]-JOYvalmin[i,j])
			If val>oldval
				oldval=val
				choice=i
				port=j
				scale=JOYvalmax[i,j]
			End If
		Next
	Next
	JOYiguess=choice
	JOYiport=port
	JOYiscale=scale
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystick()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=6
	i.text[0]="MOVEMENT"
	i.text[1]="FIRE DIRECTION"
	i.text[2]="BOMB BUTTON"
	i.text[3]="START BUTTON"
	i.text[4]="4 BUTTON FIRE"
	i.text[5]="back"
	i.value[0]=101
	i.value[1]=111
	i.value[2]=121
	i.value[3]=125
	i.value[4]=220
	i.value[5]=15
	i.selected=5
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickMovement()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Make sure your Joystick is "
	i.text[1]="CENTRED, Then press"
	i.text[2]="ANY Button"
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=102
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickMovementWait()
	DoMainMenu()

	If AnyJoy()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=103
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickMovementLeftRightAssign()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	'Move the stick you want to use for LEFT and RIGHT movment as far as it will go in one of those directions.

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Move the stick you want to use for LEFT and RIGHT"
	i.text[1]="as far as it will go in ONE of those directions."
	i.text[2]="Then release and press ANY Button."
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=104

	For j=0 To JOYmax
		For k=0 To 10
			JOYvalmin[k,j]=1024
			JOYvalmax[k,j]=0
		Next
	Next

	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystickMovementLeftRightAssign()
	Local	JOYval:Float[11,2]
	Local	i:Int
	Local	j:Int

	DoMainMenu()

	For j=0 To JOYmax
		JOYval[0,j]=Abs(JoyHat(j))
		JOYval[1,j]=Abs(JoyPitch(j))
		JOYval[2,j]=Abs(JoyR(j))
		JOYval[3,j]=Abs(JoyRoll(j))
		JOYval[4,j]=Abs(JoyU(j))
		JOYval[5,j]=Abs(JoyV(j))
		JOYval[6,j]=Abs(JoyWheel(j))
		JOYval[7,j]=Abs(JoyX(j))
		JOYval[8,j]=Abs(JoyY(j))
		JOYval[9,j]=Abs(JoyYaw(j))
		JOYval[10,j]=Abs(JoyZ(j))
	Next

	For j=0 To JOYmax
		For i=0 To 10
			If JOYval[i,j]<JOYvalmin[i,j]
				JOYvalmin[i,j]=JOYval[i,j]
			End If
			If JOYval[i,j]>JOYvalmax[i,j]
				JOYvalmax[i,j]=JOYval[i,j]
			End If
		Next
	Next

	If AnyJoy()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=105
			MakeGuess()
			JOYtype[0]=JOYiguess
			JOYport[0]=JOYiport
			JOYscale[0]=JOYiscale
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickMovementUpDownAssign()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Move the stick you want to use for UP and DOWN"
	i.text[1]="as far as it will go in ONE of those directions."
	i.text[2]="Then release and press ANY Button."
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=106

	For j=0 To JOYmax
		For k=0 To 10
			JOYvalmin[k,j]=1024
			JOYvalmax[k,j]=0
		Next
	Next
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystickMovementUpDownAssign()
	Local	JOYval:Float[11,2]
	Local	i:Int
	Local	j:Int

	DoMainMenu()

	For j=0 To JOYmax
		JOYval[0,j]=Abs(JoyHat(j))
		JOYval[1,j]=Abs(JoyPitch(j))
		JOYval[2,j]=Abs(JoyR(j))
		JOYval[3,j]=Abs(JoyRoll(j))
		JOYval[4,j]=Abs(JoyU(j))
		JOYval[5,j]=Abs(JoyV(j))
		JOYval[6,j]=Abs(JoyWheel(j))
		JOYval[7,j]=Abs(JoyX(j))
		JOYval[8,j]=Abs(JoyY(j))
		JOYval[9,j]=Abs(JoyYaw(j))
		JOYval[10,j]=Abs(JoyZ(j))
	Next

	For j=0 To JOYmax
		For i=0 To 10
			If JOYval[i,j]<JOYvalmin[i,j]
				JOYvalmin[i,j]=JOYval[i,j]
			End If
			If JOYval[i,j]>JOYvalmax[i,j]
				JOYvalmax[i,j]=JOYval[i,j]
			End If
		Next
	Next

	If AnyJoy()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=100
			MakeGuess()
			JOYtype[1]=JOYiguess
			JOYport[1]=JOYiport
			JOYscale[1]=JOYiscale
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickFire()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Make sure your Joystick is "
	i.text[1]="CENTRED, Then press"
	i.text[2]="ANY Button"
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=112
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickFireWait()
	DoMainMenu()

	If AnyJoy()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=113
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickFireLeftRightAssign()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Move the stick you want to use for LEFT and RIGHT"
	i.text[1]="as far as it will go in ONE of those directions."
	i.text[2]="Then release and press ANY Button."
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=114

	For j=0 To JOYmax
		For k=0 To 10
			JOYvalmin[k,j]=1024
			JOYvalmax[k,j]=0
		Next
	Next

	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystickFireLeftRightAssign()
	Local	JOYval:Float[11,2]
	Local	i:Int
	Local	j:Int

	DoMainMenu()

	For j=0 To JOYmax
		JOYval[0,j]=Abs(JoyHat(j))
		JOYval[1,j]=Abs(JoyPitch(j))
		JOYval[2,j]=Abs(JoyR(j))
		JOYval[3,j]=Abs(JoyRoll(j))
		JOYval[4,j]=Abs(JoyU(j))
		JOYval[5,j]=Abs(JoyV(j))
		JOYval[6,j]=Abs(JoyWheel(j))
		JOYval[7,j]=Abs(JoyX(j))
		JOYval[8,j]=Abs(JoyY(j))
		JOYval[9,j]=Abs(JoyYaw(j))
		JOYval[10,j]=Abs(JoyZ(j))
	Next

	For j=0 To JOYmax
		For i=0 To 10
			If JOYval[i,j]<JOYvalmin[i,j]
				JOYvalmin[i,j]=JOYval[i,j]
			End If
			If JOYval[i,j]>JOYvalmax[i,j]
				JOYvalmax[i,j]=JOYval[i,j]
			End If
		Next
	Next

	If AnyJoy()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=115
			MakeGuess()
			JOYtype[2]=JOYiguess
			JOYport[2]=JOYiport
			JOYscale[2]=JOYiscale
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickFireUpDownAssign()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Move the stick you want to use for UP and DOWN"
	i.text[1]="as far as it will go in ONE of those directions."
	i.text[2]="Then release and press ANY Button."
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=116

	For j=0 To JOYmax
		For k=0 To 10
			JOYvalmin[k,j]=1024
			JOYvalmax[k,j]=0
		Next
	Next
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystickFireUpDownAssign()
	Local	JOYval:Float[11,2]
	Local	i:Int
	Local	j:Int

	DoMainMenu()

	For j=0 To JOYmax
		JOYval[0,j]=Abs(JoyHat(j))
		JOYval[1,j]=Abs(JoyPitch(j))
		JOYval[2,j]=Abs(JoyR(j))
		JOYval[3,j]=Abs(JoyRoll(j))
		JOYval[4,j]=Abs(JoyU(j))
		JOYval[5,j]=Abs(JoyV(j))
		JOYval[6,j]=Abs(JoyWheel(j))
		JOYval[7,j]=Abs(JoyX(j))
		JOYval[8,j]=Abs(JoyY(j))
		JOYval[9,j]=Abs(JoyYaw(j))
		JOYval[10,j]=Abs(JoyZ(j))
	Next

	For j=0 To JOYmax
		For i=0 To 10
			If JOYval[i,j]<JOYvalmin[i,j]
				JOYvalmin[i,j]=JOYval[i,j]
			End If
			If JOYval[i,j]>JOYvalmax[i,j]
				JOYvalmax[i,j]=JOYval[i,j]
			End If
		Next
	Next

	If AnyJoy()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=100
			MakeGuess()
			JOYtype[3]=JOYiguess
			JOYport[3]=JOYiport
			JOYscale[3]=JOYiscale
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickBomb()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Make sure your Joystick is "
	i.text[1]="CENTRED, Then press"
	i.text[2]="ANY Key"
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=122
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickBombWait()
	DoMainMenu()

	If AnyKey()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=123
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickBombAssign()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Press a Button or Action"
	i.text[1]="For BOMB Activation."
	i.text[2]="Then press ANY Key."
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=124
	'JOYbombtype=0
	JOYinputtype[4]=0

	For j=0 To JOYmax
		For k=0 To 10
			JOYvalmin[k,j]=1024
			JOYvalmax[k,j]=0
		Next
	Next
	TITLEoldmy=-1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystickBombAssign()
	Local	JOYval:Float[11,2]
	Local	i:Int
	Local	j:Int

	DoMainMenu()

	For j=0 To JOYmax
		JOYval[0,j]=Abs(JoyHat(j))
		JOYval[1,j]=Abs(JoyPitch(j))
		JOYval[2,j]=Abs(JoyR(j))
		JOYval[3,j]=Abs(JoyRoll(j))
		JOYval[4,j]=Abs(JoyU(j))
		JOYval[5,j]=Abs(JoyV(j))
		JOYval[6,j]=Abs(JoyWheel(j))
		JOYval[7,j]=Abs(JoyX(j))
		JOYval[8,j]=Abs(JoyY(j))
		JOYval[9,j]=Abs(JoyYaw(j))
		JOYval[10,j]=Abs(JoyZ(j))
	Next
	For j=0 To JOYmax
		For i=0 To 31
			If JoyDown(i,j)
				'JOYbombtype=1
				JOYinputtype[4]=1
				JOYbombselect=i
				JOYbombport=j
			End If
		Next
	Next

	For j=0 To JOYmax
		For i=0 To 10
			If JOYval[i,j]<JOYvalmin[i,j]
				JOYvalmin[i,j]=JOYval[i,j]
			End If
			If JOYval[i,j]>JOYvalmax[i,j]
				JOYvalmax[i,j]=JOYval[i,j]
			End If
		Next
	Next

	If AnyKey()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=100
			'If JOYbombtype=0
			If JOYinputtype[4]=0
				MakeGuess()
				JOYtype[4]=JOYiguess
				JOYport[4]=JOYiport
				JOYscale[4]=JOYiscale
			Else
				JOYtype[4]=JOYbombselect
				JOYport[4]=JOYbombport
				JOYscale[4]=1
			End If
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function

'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickStart()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Make sure your Joystick is "
	i.text[1]="CENTRED, Then press"
	i.text[2]="ANY Key"
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=126
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickStartWait()
	DoMainMenu()

	If AnyKey()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=127
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfigJoystickStartAssign()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Press a Button or Action"
	i.text[1]="for the START button."
	i.text[2]="Then press ANY Key."
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=128
	'JOYstarttype=0
	JOYinputtype[5]=0

	For j=0 To JOYmax
		For k=0 To 10
			JOYvalmin[k,j]=1024
			JOYvalmax[k,j]=0
		Next
	Next
	TITLEoldmy=-1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystickStartAssign()
	Local	JOYval:Float[11,2]
	Local	i:Int
	Local	j:Int

	DoMainMenu()

	For j=0 To JOYmax
		JOYval[0,j]=Abs(JoyHat(j))
		JOYval[1,j]=Abs(JoyPitch(j))
		JOYval[2,j]=Abs(JoyR(j))
		JOYval[3,j]=Abs(JoyRoll(j))
		JOYval[4,j]=Abs(JoyU(j))
		JOYval[5,j]=Abs(JoyV(j))
		JOYval[6,j]=Abs(JoyWheel(j))
		JOYval[7,j]=Abs(JoyX(j))
		JOYval[8,j]=Abs(JoyY(j))
		JOYval[9,j]=Abs(JoyYaw(j))
		JOYval[10,j]=Abs(JoyZ(j))
	Next
	For j=0 To JOYmax
		For i=0 To 31
			If JoyDown(i,j)
				'JOYstarttype=1
				JOYinputtype[5]=1
				JOYbombselect=i
				JOYbombport=j
			End If
		Next
	Next

	For j=0 To JOYmax
		For i=0 To 10
			If JOYval[i,j]<JOYvalmin[i,j]
				JOYvalmin[i,j]=JOYval[i,j]
			End If
			If JOYval[i,j]>JOYvalmax[i,j]
				JOYvalmax[i,j]=JOYval[i,j]
			End If
		Next
	Next

	If AnyKey()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=100
			'If JOYstarttype=0
			If JOYinputtype[5]=0
				MakeGuess()
				JOYtype[5]=JOYiguess
				JOYport[5]=JOYiport
				JOYscale[5]=JOYiscale
			Else
				JOYtype[5]=JOYbombselect
				JOYport[5]=JOYbombport
				JOYscale[5]=1
			End If
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Audio
'////////////////////////////////////////////////////////////////////////////////
Function	SetupAudio()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="MUSIC VOLUME"
	i.text[1]="SOUND FX VOLUME"
	i.text[2]="back"
	i.value[0]=131
	i.value[1]=133
	i.value[2]=4
	i.selected=2
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Audio
'////////////////////////////////////////////////////////////////////////////////
Function	SetupMusicVolume()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=4
	i.text[0]="Use UP and DOWN to change VOLUME"
	i.text[1]=""
	i.text[2]=""
	i.text[3]=""
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.value[3]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=132
	TITLEoldmy=-1
	JOYpressed=1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Music Volume
'////////////////////////////////////////////////////////////////////////////////
Function	DoMusicVolume()
	Local	jy:Float
	Local	mo:Int
	Local	mx:Int
	Local	my:Int

	DoMainMenu()

	If MUSICvolume>0.01
		AddImage(GFXloadbar,GFXw/2,(GFXh*0.75),0,16,255,16,1,0,MUSICvolume*200,1,lightBLEND)
		PrintGame(Int(MUSICvolume*100)+"%",GFXw/2,(GFXh*0.73),8,64,8,1,ALPHABLEND,1)
	Else
		PrintGame("MUTE",GFXw/2,(GFXh*0.73),32,192,32,1,ALPHABLEND,1)
	End If

	mx=MouseX()
	my=MouseY()

	If mx>((GFXw*0.2)-24) And mx<((GFXw*0.2)+24) And my>((GFXh*0.73)-8) And my<((GFXh*0.73)+32)
		mo=1
	Else
		If mx>((GFXw*0.8)-24) And mx<((GFXw*0.8)+24) And my>((GFXh*0.73)-8) And my<((GFXh*0.73)+32)
			mo=2
		Else
			If mx>((GFXw*0.5)-40) And mx<((GFXw*0.5)+40) And my>((GFXh*0.78)) And my<((GFXh*0.78)+32)
				mo=3
			Else
				mo=0
			End If
		End If
	End If

	Select mo
		Case	0
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,32,192,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
		Case	1
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,255,255,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,32,192,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
		Case	2
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,32,192,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,255,255,32,1,ALPHABLEND,1)
		Case	3
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,255,255,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
	End Select

	jy=JoyGet(1)
	If (jy<-0.5 Or KeyDown(CONTROLup) Or KeyDown(KEY_UP) Or (MouseDown(1) And mo=2)) And MUSICvolume<1.0
		MUSICvolume:+0.01
	Else
		If (jy>0.5 Or KeyDown(CONTROLdown) Or KeyDown(KEY_DOWN) Or (MouseDown(1) And mo=1)) And MUSICvolume>0.0
			MUSICvolume:-0.01
		End If
	End If

	If MUSICtype=0
		If TITLEmusicon=1
			SetChannelVolume(SFXtitlemusicCH,MUSICvolume)
		End If
	Else
		If MUSICon=1
			SetChannelVolume(SFXtitlemusicCH,MUSICvolume)
		End If
	End If

	If AnyJoy()=1 Or (MouseDown(1) And mo=3) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or KeyDown(KEY_ESCAPE)
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=130
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Audio
'////////////////////////////////////////////////////////////////////////////////
Function	SetupSFXVolume()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=4
	i.text[0]="Use UP and DOWN to change VOLUME"
	i.text[1]=""
	i.text[2]=""
	i.text[3]=""
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.value[3]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=134
	TITLEoldmy=-1
	JOYpressed=1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Music Volume
'////////////////////////////////////////////////////////////////////////////////
Function	DoSFXVolume()
	Local	jy:Float
	Local	mo:Int
	Local	mx:Int
	Local	my:Int
	Local	change:Int

	DoMainMenu()

	If SFXvolume>0.01
		AddImage(GFXloadbar,GFXw/2,(GFXh*0.75),0,16,255,16,1,0,SFXvolume*200,1,lightBLEND)
		PrintGame(Int(SFXvolume*100)+"%",GFXw/2,(GFXh*0.73),8,64,8,1,ALPHABLEND,1)
	Else
		PrintGame("MUTE",GFXw/2,(GFXh*0.73),32,192,32,1,ALPHABLEND,1)
	End If

	mx=MouseX()
	my=MouseY()

	If mx>((GFXw*0.2)-24) And mx<((GFXw*0.2)+24) And my>((GFXh*0.73)-8) And my<((GFXh*0.73)+32)
		mo=1
	Else
		If mx>((GFXw*0.8)-24) And mx<((GFXw*0.8)+24) And my>((GFXh*0.73)-8) And my<((GFXh*0.73)+32)
			mo=2
		Else
			If mx>((GFXw*0.5)-40) And mx<((GFXw*0.5)+40) And my>((GFXh*0.78)) And my<((GFXh*0.78)+32)
				mo=3
			Else
				mo=0
			End If
		End If
	End If

	Select mo
		Case	0
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,32,192,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
		Case	1
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,255,255,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,32,192,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
		Case	2
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,32,192,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,255,255,32,1,ALPHABLEND,1)
		Case	3
			PrintGame("<<<<",GFXw*0.2,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
			PrintGame("done",GFXw*0.5,GFXh*0.78,255,255,32,1,ALPHABLEND,1)
			PrintGame(">>>>",GFXw*0.8,GFXh*0.73,32,192,32,1,ALPHABLEND,1)
	End Select

	change=0
	jy=JoyGet(1)
	If (jy<-0.5 Or KeyDown(CONTROLup) Or KeyDown(KEY_UP) Or (MouseDown(1) And mo=2)) And SFXvolume<1.0
		SFXvolume:+0.01
		change=1
	Else
		If (jy>0.5 Or KeyDown(CONTROLdown) Or KeyDown(KEY_DOWN) Or (MouseDown(1) And mo=1)) And SFXvolume>0.0
			SFXvolume:-0.01
			change=1
		End If
	End If

	If AnyJoy()=1 Or (MouseDown(1) And mo=3) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or KeyDown(KEY_ESCAPE)
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=130
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Graphics Driver
'////////////////////////////////////////////////////////////////////////////////
Function	SetupGFXDriver()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.62)
	i.entries=3
	i.text[0]="OpenGL"
	i.text[1]="DirectX"
	i.text[2]="back"
	i.value[0]=141
	i.value[1]=142
	i.value[2]=143
	i.selected=GFXdriver
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.80)
	i.entries=2
	i.text[0]="you will have to restart the game"
	i.text[1]="for the settings to take effect"
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Graphics Driver OpenGL
'////////////////////////////////////////////////////////////////////////////////
Function	DoGFXOpengl()
	ClearList(MENUlist)
	GFXdriver=0
	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Graphics Driver OpenGL
'////////////////////////////////////////////////////////////////////////////////
Function	DoGFXDirectX()
	ClearList(MENUlist)
	GFXdriver=1
	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Graphics Driver OpenGL
'////////////////////////////////////////////////////////////////////////////////
Function	DoGFXDone()
	ClearList(MENUlist)
	TITLEmode=27
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Screen Mode
'////////////////////////////////////////////////////////////////////////////////
Function	SetupCredits()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.4)
	i.entries=12
	i.text[0]="C R E D I T S"
	i.text[1]=""
	i.text[2]="PROGRAMMING & GRAPHICS"
	i.text[3]="andy noble"
	i.text[4]=""
	i.text[5]="MUSIC           GRID MATHS"
	i.text[6]="paul tankard                mark incitti"
	i.text[7]=""
	i.text[8]="THANKS TO THE FOLLOWING"
	i.text[9]="all the guys at retrospec, mark sibly"
	i.text[10]="stroods, tolls, dek, john, molls, scam"
	i.text[11]="cath, terry, max, ginge, merls, dave, wiebo"
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.875)
	i.entries=1
	i.text[0]="back"
	i.value[0]=152
	i.selected=0
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=151
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Screen Mode
'////////////////////////////////////////////////////////////////////////////////
Function	DoCredits()
	ClearList(DRAWlist)
	ClearSFX()
	DrawStars()
	DoParticles()
	DoMenus()

	If KeyDown(KEY_ESCAPE)
		TITLEmode=152
		AddSFX(cSFXmenuaccept,-1)
	End If

	AddImage(GFXplayersight,MouseX(),MouseY(),0,64,255,64,1,0,1,1,alphaBLEND)

	TITLEfwpause:-1
	If TITLEfwpause<0
		AddExplosion(Rnd(WINleft,WINright),Rnd(WINtop,WINbot))
		TITLEfwpause=2
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Screen Mode
'////////////////////////////////////////////////////////////////////////////////
Function	CreditsDone()
	ClearList(MENUlist)
	SetupOptions()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Stars
'////////////////////////////////////////////////////////////////////////////////
Function SetupStars2()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=4
	i.text[0]="OFF"
	i.text[1]="MEDIUM"
	i.text[2]="HIGH"
	i.text[3]="back"
	i.value[0]=171
	i.value[1]=172
	i.value[2]=173
	i.value[3]=27
	Select CONFstars
		Case	0
			i.selected=0
		Case	1
			i.selected=1
		Case	2
			i.selected=2
	End Select
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function StarsOFF()
	CONFstars=0
	ClearList(STARlist)
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function StarsMed()
	CONFstars=1
	MAXSTARS=128
	ClearList(STARlist)
	SetupStars()
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function StarsHigh()
	CONFstars=2
	MAXSTARS=256
	ClearList(STARlist)
	SetupStars()
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup 
'////////////////////////////////////////////////////////////////////////////////
Function SetupHitScore()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="OFF"
	i.text[1]="ON"
	i.text[2]="back"
	i.value[0]=181
	i.value[1]=182
	i.value[2]=27
	Select CONFhotscore
		Case	0
			i.selected=0
		Case	1
			i.selected=1
	End Select
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function HitScoreOFF()
	CONFhotscore=0
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function HitScoreON()
	CONFhotscore=1
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Stars
'////////////////////////////////////////////////////////////////////////////////
Function SetupExplosions2()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=4
	i.text[0]="OFF"
	i.text[1]="MEDIUM"
	i.text[2]="HIGH"
	i.text[3]="back"
	i.value[0]=191
	i.value[1]=192
	i.value[2]=193
	i.value[3]=27
	Select CONFexplosions
		Case	0
			i.selected=0
		Case	1
			i.selected=1
		Case	2
			i.selected=2
	End Select
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function ExplosionsOFF()
	CONFexplosions=0
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function ExplosionsMed()
	CONFexplosions=1
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function ExplosionsHigh()
	CONFexplosions=2
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Stars
'////////////////////////////////////////////////////////////////////////////////
Function SetupGrid2()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=0
	i.y=(GFXh*0.72)
	i.entries=4
	i.text[0]="OFF"
	i.text[1]="NORMAL"
	i.text[2]="HIGH"
	i.text[3]="back"
	i.value[0]=201
	i.value[1]=202
	i.value[2]=203
	i.value[3]=27
	Select CONFgrid
		Case	0
			i.selected=0
		Case	1
			i.selected=1
		Case	2
			i.selected=2
	End Select
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	TITLEmode=1
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function GridOFF()
	CONFgrid=0
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function GridMed()
	CONFgrid=1
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	
'////////////////////////////////////////////////////////////////////////////////
Function GridHigh()
	CONFgrid=2
	SetupGameSettings()
	TITLEmode=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfig4Button()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=3
	i.text[0]="Make sure your Joystick is "
	i.text[1]="CENTRED, Then press"
	i.text[2]="ANY Key"
	i.value[0]=0
	i.value[1]=0
	i.value[2]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=221
	TITLEoldmy=-1
	TITLEcountnh=1
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfig4ButtonWait1()
	DoMainMenu()

	If AnyKey()=1
		If JOYpressed=0
			JOYpressed=1
			TITLEmode=222
			ClearList(MENUlist)
			AddSFX(cSFXmenuaccept,-1)
		End If
	Else
		JOYpressed=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfig4ButtonAssign1()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=2
	i.text[0]="Press a Button for FIRE UP"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=223

	TITLEoldmy=-1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystick4ButtonAssign1()
	Local	i:Int
	Local	j:Int
	Local	hit:Int

	DoMainMenu()

	hit=0
	If JOYpressed=0
		For j=0 To JOYmax
			For i=0 To 31
				If JoyDown(i,j)
					JOY4firebutton[0]=i
					JOY4fireport[0]=j
					hit=1
				End If
			Next
		Next
	End If

	If AnyJoy()=0
		JOYpressed=0
	End If

	If hit=1
		TITLEmode=224
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If

	If KeyDown(KEY_ESCAPE)
		JOYpressed=1
		TITLEmode=100
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfig4ButtonAssign2()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=2
	i.text[0]="Press a Button for FIRE DOWN"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=225

	TITLEoldmy=-1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystick4ButtonAssign2()
	Local	i:Int
	Local	j:Int
	Local	hit:Int

	DoMainMenu()

	hit=0
	If JOYpressed=0
		For j=0 To JOYmax
			For i=0 To 31
				If JoyDown(i,j)
					JOY4firebutton[1]=i
					JOY4fireport[1]=j
					hit=1
				End If
			Next
		Next
	End If

	If AnyJoy()=0
		JOYpressed=0
	End If

	If hit=1
		TITLEmode=226
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If

	If KeyDown(KEY_ESCAPE)
		JOYpressed=1
		TITLEmode=100
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfig4ButtonAssign3()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=2
	i.text[0]="Press a Button for FIRE LEFT"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=227

	TITLEoldmy=-1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystick4ButtonAssign3()
	Local	i:Int
	Local	j:Int
	Local	hit:Int

	DoMainMenu()

	hit=0
	If JOYpressed=0
		For j=0 To JOYmax
			For i=0 To 31
				If JoyDown(i,j)
					JOY4firebutton[2]=i
					JOY4fireport[2]=j
					hit=1
				End If
			Next
		Next
	End If

	If AnyJoy()=0
		JOYpressed=0
	End If

	If hit=1
		TITLEmode=228
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If

	If KeyDown(KEY_ESCAPE)
		JOYpressed=1
		TITLEmode=100
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function SetupConfig4ButtonAssign4()
	Local	i:tMENU
	Local	k:Int
	Local	j:Int

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.72)
	i.entries=2
	i.text[0]="Press a Button for FIRE RIGHT"
	i.text[1]="press escape to cancel"
	i.value[0]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)

	JOYpressed=1
	TITLEmode=229

	TITLEoldmy=-1
	TITLEcountnh=1

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Config Joystick
'////////////////////////////////////////////////////////////////////////////////
Function ConfigJoystick4ButtonAssign4()
	Local	i:Int
	Local	j:Int
	Local	hit:Int

	DoMainMenu()

	hit=0
	If JOYpressed=0
		For j=0 To JOYmax
			For i=0 To 31
				If JoyDown(i,j)
					JOY4firebutton[3]=i
					JOY4fireport[3]=j
					hit=1
				End If
			Next
		Next
	End If

	If AnyJoy()=0
		JOYpressed=0
	End If

	If hit=1
		JOYpressed=1
		TITLEmode=100
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If

	If KeyDown(KEY_ESCAPE)
		JOYpressed=1
		TITLEmode=100
		ClearList(MENUlist)
		AddSFX(cSFXmenuaccept,-1)
	End If
End Function


